<?php
/**
 * Class for the Requests page.
 *
 * @package Freesoul Deactivate Plugins
 */

defined( 'ABSPATH' ) || exit; // Exit if accessed directly.

class FDP_Custom_Rows_Inputs_Page extends FDP_Custom_Rows_Page {
  public $urls;
  public $home_url;
  public $section_id;

  public function before_section( $page_slug ){
    $this->section_id = 'eos-dp-by-post-request-section';
    $this->urls = eos_dp_get_option( 'eos_dp_by_post_request' );
    if( !$this->urls || '' === $this->urls ){
  		$this->urls = array( array( 'url' => '','plugins' => '' ) );
  	}
  	else{
  		$this->urls[] = array( 'url' => '','plugins' => '' );
  	}
  	$this->home_url = get_home_url();
    ?>
    <h2><?php esc_html_e( 'Uncheck the plugins you want to disable by Post request','eos-dp-pro' ); ?></h2>
		<h2><span class="dashicons dashicons-warning"></span><?php _e( 'It will work only for Post requests','eos-dp-pro' ); ?></h2>
    <?php
  }
  public function tableBody( $page_slug ){
    $row = 0;
    $urlsN = count( $this->urls );
    foreach( $this->urls as $urlA ){
    ?>
      <tr class="eos-dp-url eos-dp-post-row<?php echo $row + 1 === $urlsN ? ' eos-hidden' : '';echo isset( $urlA['needs_url'] ) && absint( $urlA['needs_url'] ) > 0 ? ' eos-dp-need-from-singe' : ''; ?>">
        <td class="eos-dp-post-name-wrp">
          <span class="eos-dp-not-active-wrp"><input title="<?php _e( 'Activate/deactivate all plugins for this Post request','eos-dp-pro' ); ?>" class="eos-dp-global-chk-row" type="checkbox" /></span>
          <span class="dashicons dashicons-move" title="<?php _e( 'Move it up to assign higher priority','eos-dp-pro' ); ?>"></span>
          <input type="text" class="eos-dp-url-input" title="<?php echo isset( $urlA['url'] ) ? esc_attr( $urlA['url'] ) : ''; ?>" placeholder="<?php esc_attr_e( 'Post request key','eos-dp-pro' ); ?>" value="<?php echo isset( $urlA['url'] ) ? esc_attr( $urlA['url'] ) : ''; ?>" />
          <span class="eos-dp-delete-url dashicons dashicons-trash hover" title="<?php _e( 'Delete','eos-dp-pro' ); ?>"></span>
          &nbsp;&nbsp;<a class="eos-dp-copy" href="#"><span class="dashicons dashicons-admin-page" style="font-size:30px"></span></a>
          &nbsp;&nbsp;<a class="eos-dp-paste" href="#"><span class="dashicons dashicons-category" style="font-size:30px"></span></a>
          <span class="eos-dp-x-space"></span>
        </td>
      <?php
      $k = 0;
      foreach( $this->active_plugins as $plugin ){
        if( in_array( $plugin,array_keys( $this->plugins_by_dirs ) ) ){
          if( !isset( $urlA['plugins'] ) ){
            $active = true;
          }
          else{
            $active = !in_array( $plugin,explode( ',',$urlA['plugins'] ) ) ? true : false;
          }
          ?>
          <td class="center<?php echo $active ? ' eos-dp-active' : ''; ?>" data-path="<?php echo esc_attr( $plugin ); ?>">
            <div class="eos-dp-td-chk-wrp eos-dp-td-url-chk-wrp">
              <input class="eos-dp-row-<?php echo $row; ?> eos-dp-col-<?php echo $k + 1; ?>" type="checkbox"<?php echo $active ? ' checked' : ''; ?> />
            </div>
          </td>
        <?php
        ++$k;
        }
      } ?>
      </tr>
      <?php
      ++$row;
    }
    ?>
    <tr>
      <td id="eos-dp-url-actions" style="border:none;padding:0">
        <button id="eos-dp-add-url" style="margin-top:16px"><?php _e( 'Add Post request','eos-dp-pro' ); ?></button>
      </td>
    </tr>
    <?php
  }
}
