<?php
/**
 * Class for the Rest APIs page.
 *
 * @package Freesoul Deactivate Plugins
 */

defined( 'ABSPATH' ) || exit; // Exit if accessed directly.

class FDP_Rest_Api_Page extends FDP_Custom_Rows_Page {
  public $urls;
  public $section_id;
  public $home_url;

  public function before_section( $page_slug ){
    $this->section_id = 'eos-dp-rest-api-section';
    $this->urls = eos_dp_get_option( 'eos_dp_by_rest_api' );
    $this->home_url = get_home_url();
    if( !$this->urls || '' === $this->urls ){
  		$this->urls = array( array( 'url' => '','plugins' => '' ) );
  	}
  	else{
  		$this->urls[] = array( 'url' => '','plugins' => '' );
  	}
    wp_nonce_field( 'eos_dp_rest_api_setts','eos_dp_rest_api_setts' );
    ?>
    <h2><?php esc_html_e( 'Uncheck the plugins you want to disable for the Rest API','eos-dp-pro' ); ?></h2>
		<h2><span class="dashicons dashicons-warning"></span><?php _e( 'It will work only for the Rest Api','eos-dp-pro' ); ?></h2>
		<div class="eos-dp-explanation">
      <p><?php _e( 'Use the star "*" as replacement of groups of characters.','eos-dp-pro' ); ?></p>
			<p><?php printf( esc_html__( 'E.g. %s/create-user/* will match Rest API like %s/create-user/john/, %s/create-user/tim/...','eos-dp-pro' ),$this->home_url,$this->home_url,$this->home_url ); ?></p>
		</div>
    <?php
    add_action( 'fdp_after_last_plugin',function( $action,$k ){
      $ajaxTheme = eos_dp_pro_get_option( 'eos_dp_by_rest_api_theme' );
    ?>
    <td class="center<?php echo !isset( $ajaxTheme[$action] ) || $ajaxTheme[$action] ? ' eos-dp-active' : ''; ?>">
      <div class="eos-dp-td-chk-wrp eos-dp-td-url-chk-wrp">
        <input class="eos-dp-row-theme eos-dp-col-<?php echo esc_attr( $k + 1 ); ?>" data-checked="checked" type="checkbox" checked />
      </div>
    </td>
    <?php
    },10,2 );
  }
}
