<?php
defined( 'ABSPATH' ) || exit; // Exit if accessed directly.

//Add premium pointers to Singles settings
add_filter( 'fdp_pointers_singles',function( $pointers ){
	$new_pointers = array();
	$pointers_pro = array(
		'fdp_getting_start' => 'from_free',
		'fdp_pro_autosuggest_plugins' => array(
			__( 'Autosuggestion' ,'eos-dp-pro'),
			sprintf( __( "Click on the plus icon before the switch to open the action buttons panel.%sClick on the \"checked plugin\" icon to ask FDP to suggest the plugins which are not used on the page.","eos-dp" ),'<p>','</p>','<p>','</p>' ),
			'.fdp-row-actions-ico',
			'.fdp-row-actions-ico',
			40,
			'.eos-dp-actions .eos-dp-pro-autosettings',
			'top',
			__( 'Next','eos-dp-pro' ),
			''
		),
		'fdp_check_preview' => array(
			__( 'Check the preview' ,'eos-dp-pro'),
			sprintf( __( "%sClick on the lens icon to see the preview of the page loading the plugins that remain active.%s%s.","eos-dp" ),'<p>','</p>','<p>','</p>' ),
			'.eos-dp-theme-sel+.eos-dp-preview',
			'',
			20,
			'.eos-dp-theme-sel+.eos-dp-preview',
			'top',
			__( 'Next','eos-dp-pro' ),
			''
		),
		'fdp_pro_autosuggest_all_rows' => array(
			__( 'Autosuggest all rows' ,'eos-dp-pro'),
			sprintf( __( 'Clicking on "Autosuggest all rows" FDP will suggest the used plugins starting from the rist row, and will continue for all the other rows of the page.".%sDon\'t close the browser window, in another case the process will be interrupted.%s.','eos-dp-pro' ),'<p>','</p>' ),
			'#eos-dp-autosuggest-all',
			'.fdp-row-actions-ico',
			20,
			'#eos-dp-autosuggest-all',
			'top',
			__( 'Next','eos-dp-pro' ),
			''
		),
		'fdp_plugins_slider' => 'from_free',
		'fdp_save' => 'from_free',
		'fdp_other_singles' => 'from_free',
		'fdp_post_types' => 'from_free'
	);
	foreach( $pointers_pro as $pkey => $pointer ){
		if( is_string( $pointer ) && 'from_free' === $pointer ){
			$new_pointers[$pkey] = $pointers[$pkey];
		}
		elseif( $pointer ){
			$new_pointers[$pkey] = $pointers_pro[$pkey];
		}
	}
	return $new_pointers;
} );

add_filter( 'fdp_admin_pointers-eos_dp_pro_settings', 'eos_dp_pro_register_pointers_main_settings' );
function eos_dp_pro_register_pointers_main_settings( $p ){
  $pointers = array(
    'fdp_after_plugin_activation' => array(
      __( 'After activating a new plugin' ,'eos-dp-pro'),
      __( 'Decide what to do after a user activates a new plugin. Should FDP activate or deactiate it on the FDP settings? Would you like to be informed?.','eos-dp-pro' ),
      '#notification_after_plugin_activation', //element
      '', //click
      '140', //offset
      '', //indicated
      'top',	//edge
      __( 'Next','eos-dp-pro' ), //button text
      '' //CSS class added to elemeent
    ),
    'fdp_after_plugin_deactivation' => array(
      __( 'After deactivating a plugin' ,'eos-dp-pro'),
      __( 'Would you like to be informed when a user deactivates any plugin?.','eos-dp-pro' ),
      '#notification_after_plugin_deactivation', //element
      '', //click
      '-4', //offset
      '', //indicated
      'top',	//edge
      __( 'Next','eos-dp-pro' ), //button text
      '' //CSS class added to elemeent
    ),
    'fdp_after_post_saving' => array(
      __( 'After saving a page' ,'eos-dp-pro'),
      __( 'After saving a page, would you like FDP to check if for mistake some plugins that had to be active were deactivated by the user?','eos-dp-pro' ),
      '#after_saving_post', //element
      '', //click
      '', //offset
      '', //indicated
      'top',	//edge
      __( 'Next','eos-dp-pro' ), //button text
      '' //CSS class added to elemeent
    ),
    'fdp_notification_after_post_saving' => array(
      __( 'Notification after saving a page' ,'eos-dp-pro'),
      __( 'If after saving a page FDP detects some plugins that had to be active but they weren not, would you like to be informed?','eos-dp-pro' ),
      '#after_saving_notification', //element
      '', //click
      '', //offset
      '', //indicated
      'top',	//edge
      __( 'Next','eos-dp-pro' ), //button text
      '' //CSS class added to elemeent
    ),
    'fdp_notification_email' => array(
      __( 'Notification email' ,'eos-dp-pro'),
      __( 'What email should receive the notifications?','eos-dp-pro' ),
      '#notifications_email', //element
      '', //click
      '', //offset
      '', //indicated
      'top',	//edge
      __( 'Next','eos-dp-pro' ), //button text
      '' //CSS class added to elemeent
    ),
    'fdp_dependencies' => array(
      __( 'Dependencies' ,'eos-dp-pro'),
      __( 'There are some plugins which depend on other plugins, e.g. add-ons of WooCommerce. Should FDP try to understand when a plugin depends on another one and disable it if the "parent" plugin is disabled (recommended)?','eos-dp-pro' ),
      '#dependencies', //element
      '', //click
      '', //offset
      '', //indicated
      'top',	//edge
      __( 'Next','eos-dp-pro' ), //button text
      '' //CSS class added to elemeent
    ),
    'fdp_dev_mode' => array(
      __( 'Development mode' ,'eos-dp-pro'),
      __( 'The best practice is testing the optiimization on a staging insttallation, but if you need to disable FDP for the normal visitors, and in the same time see the effect of the optimizatin, activate the Development Mode.','eos-dp-pro' ),
      '#dev_mode', //element
      '', //click
      '', //offset
      '', //indicated
      'top',	//edge
      __( 'Next','eos-dp-pro' ), //button text
      '' //CSS class added to elemeent
    ),
  );
  return eos_dp_build_pointers( $p,$pointers,'fdp_pointers_main_settings' );
}
