<?php
function eos_dp_pro_code_browser_callback(){
  if( !isset( $_GET['path'] ) ){
    esc_html_e( 'Path to file not specified.','fdp-pro' );
    return;
  }
  $path = str_replace( '//','/',ABSPATH.esc_attr( $_GET['path'] ) );
  $code = $file_size = '';
  $id = isset( $_GET['id'] ) ? esc_html( $_GET['id'] ) : '';
  if( file_exists( $path ) ){
    $code = file_get_contents( $path );
    $file_size = round( filesize( $path )/1024,1 );
    $last_change = date( 'F d Y H:i:s', filectime( $path ) );
  }
  $from = isset( $_GET['from'] ) ? esc_html( $_GET['from'] ) : '';
  $from = isset( $_GET['from_type'] ) ? sprintf( 'From: %s (%s).',$from,$_GET['from_type'] )  : '';
  $file_name = basename( $path );
?>
<p>
  <?php echo esc_html( sprintf( 'File name: %s. Slug: %s. %s Size: %s kB. Last change: %s.',$file_name,$id,$from,$file_size,$last_change ) );  ?>
  <a class="dashicons dashicons-download" href="<?php echo str_replace( ABSPATH,get_site_url().'/',$path ); ?>" download="<?php echo esc_attr( $file_name ); ?>"></a>
</p>
<textarea id="fdp-code-browser" class="large-text code" rows="40"><?php echo esc_textarea( $code ); ?></textarea>
<?php
}
