<?php
defined( 'ABSPATH' ) || exit; // Exit if accessed directly

//Callback for the settings page
function eos_dp_pro_hooks_recorder_callback(){
  wp_nonce_field( 'eos_dp_pro_hooks_recorder_start_nonce','eos_dp_pro_hooks_recorder_start_nonce' );
  wp_nonce_field( 'eos_dp_pro_hooks_recorder_stop_nonce','eos_dp_pro_hooks_recorder_stop_nonce' );
  wp_enqueue_script( 'fdp-hooks-recorder',EOS_DP_PRO_PLUGIN_URL.'/admin/js/eos-dp-pro-hooks-recorder-1.0.0.js',array(),null,true );
  wp_localize_script( 'fdp-hooks-recorder','eos_ahr',array( 'ajax_url' => admin_url( 'admin-ajax.php' ) ) );
  $rec_id = uniqid();
  eos_dp_navigation();
?>
<section id="eos-dp-pro-record-hook">
  <style>
  .eos-dp-is-recording img{
    animation: pulse-animation 0.5s infinite;
  }
  #eos-dp-pro-rec-hook-stop{
    pointer-events:none;
    cursor:default;
    opacity:0.7
  }
  .eos-dp-is-recording+#eos-dp-pro-rec-hook-stop{
    pointer-events:initial;
    cursor:pointer;
    opacity:1
  }
  #fdp-recorded-hooks-filter span.fdp-rec-hooks-url {
    background-color: #D3C4B8;
    color: #253042;
    padding: 6px;
    margin-bottom: 6px;
    display: inline-block;
    margin-<?php echo is_rtl() ? 'left' : 'right';?>: 6px
  }
  #eos-dp-pro-hooks-table td {
    max-width: 200px !important;
  }
  @keyframes pulse-animation {
    0% {
      transform:scale(1);
    }
    100% {
      transform:scale(1.2);
    }
  }
  #eos-dp-pro-hooks-table td{max-width:300px}
  </style>
  <h2><?php esc_html_e( 'Hooks Recorder','eos-dp-pro' ); ?></h2>
  <ol>
    <li><?php esc_html_e( 'Start the recording','eos-dp-pro' ); ?></li>
    <li><?php esc_html_e( 'Do the action (e.g. load a page, submit a form, save the settings of a plugin...)','eos-dp-pro' ); ?></li>
    <li><?php esc_html_e( 'Stop the recording','eos-dp-pro' ); ?></li>
    <li><?php esc_html_e( 'Wait for a second, and you will see the recorded hooks','eos-dp-pro' ); ?></li>
  </ol>
  <button id="eos-dp-pro-rec-hook-start" class="hover eos-dp-pro-not-active" style="cursor:pointer" data-rec_id="<?php echo $rec_id; ?>">
    <span><img style="width:16px;height:16px;margin-top:3px;margin-bottom:-3px" src="<?php echo EOS_DP_PRO_PLUGIN_URL.'/img/record-icon.png'; ?>" /></span>
    <?php esc_html_e( 'Start recording','eos-dp-pro' ); ?>
  </button>
  <button id="eos-dp-pro-rec-hook-stop"  class="hover eos-dp-pro-not-active" style="cursor:pointer" data-rec_id="<?php echo $rec_id; ?>">
    <span><img style="width:16px;height:16px;margin-top:3px;margin-bottom:-3px" src="<?php echo EOS_DP_PRO_PLUGIN_URL.'/img/stop-icon.png'; ?>" /></span>
    <?php esc_html_e( 'Stop recording','eos-dp-pro' ); ?>
  </button>
  <input id="eos-dp-pro-recorded-actions" type="hidden" />
  <div id="eos-dp-pro-recorded-actions-msg" class="eos-hidden">
    <p><?php esc_html_e( 'Click on the action you want to add','eos-dp-pro' ); ?></p>
  </div>
  <div id="fdp-recorded-hooks-filter" class="eos-hidden" style="margin-top:16px;margin-bottom:16px">
    <span><?php esc_html_e( 'Filter','eos-dp-pro' ); ?></span>
    <select id="fdp-recorded-hooks-filter-sel" class="eos-dp-progress">
      <option value="all"><?php esc_html_e( 'All','eos-dp-pro' ); ?></option>
      <option value="core"><?php esc_html_e( 'Core','eos-dp-pro' ); ?></option>
      <option value="theme"><?php esc_html_e( 'Theme','eos-dp-pro' ); ?></option>
      <option value="plugin"><?php esc_html_e( 'Plugins','eos-dp-pro' ); ?></option>
      <option value="---" disabled>---</option>
      <?php
      if( function_exists( 'eos_dp_active_plugins') ){
        $active_plugins = eos_dp_active_plugins();
        foreach( $active_plugins as $plugin ){
          ?>
          <option value="<?php echo esc_attr( dirname( $plugin ) ); ?>"><?php echo esc_html( ucwords( str_replace( '-',' ',dirname( $plugin ) ) ) ); ?></option>
          <?php
        }
      }
      ?>
    </select>
    <div>
      <p><?php esc_html_e( 'Called URLs:','eos-dp-pro' ); ?></p>
      <p id="eos-dp-pro-uri"></p>
    </div>
  </div>
  <div id="eos-dp-pro-table-wrp" style="margin-top:32px"></div>
</section>
<?php
}
