<?php
defined( 'ABSPATH' ) || exit; // Exit if accessed directly

//It adds the import/export section
function eos_dp_pro_import_export_callback(){
	$upload_dir = wp_upload_dir();
	$fdp_keys = eos_dp_pro_options_keys();
	eos_dp_navigation();
	?>
	<section id="eos-dp-setts">
		<div id="fdp-migr-actions">
			<div id="fdp-pro-export-sec">
				<h2><?php esc_html_e( 'Export FDP options','eos-dp-pro' ); ?></h2>
				<table>
					<tbody>
				<?php foreach( $fdp_keys as $key => $desc ){ ?>
						<tr>
							<th style="text-align:initial"><label id="fdp-export-<?php echo esc_attr( $key ); ?>-chk"><?php echo esc_html( $desc ); ?></label>&nbsp;</th>
							<td class="eos-dp-active">
								<div class="eos-dp-td-chk-wrp">
									<input type="checkbox" id="fdp-export-<?php echo esc_attr( $key ); ?>-chk" class="fdp-opt-chk" value="1" checked data-key="<?php echo $key; ?>" />
								</div>
							</td>
						</tr>
						<?php } ?>
					</tbody>
				</table>
				<p style="margin-top:32px"><span id="fdp-migr-export" class="button"><span class="dashicons dashicons-download" style="margin:4px 0"></span><?php esc_html_e( 'Export actual settings','fdp-migr' ); ?></span></p>
			</div>
			<hr style="margin:32px 0"/>
			<div id="fdp-pro-import-sec">
				<h2><?php esc_html_e( 'Import FDP options','eos-dp-pro' ); ?></h2>
				<table>
					<tbody>
					<?php foreach( $fdp_keys as $key => $desc ){
						$checked = in_array( $key,array( 'eos_post_types_plugins' ) ) ? ' checked' : '';
						?>
						<tr>
							<th style="text-align:initial"><label id="fdp-import-<?php echo esc_attr( $key ); ?>-chk"><?php echo esc_html( $desc ); ?></label>&nbsp;</th>
							<td<?php echo ' checked' === $checked ? ' class="eos-dp-active"' : ''; ?>>
								<div class="eos-dp-td-chk-wrp">
									<input type="checkbox" id="fdp-import-<?php echo esc_attr( $key ); ?>-chk" class="fdp-opt-chk" value="1" data-key="<?php echo $key; ?>" <?php echo $checked; ?>/>
								</div>
							</td>
						</tr>
						<?php } ?>
					</tbody>
				</table>
				<?php if( current_user_can( 'activate_plugins' ) ){ ?>
				<p style="margin-top:32px"><span id="fdp-migr-import" class="button"><span class="dashicons dashicons-upload" style="margin:4px 0"></span><?php esc_html_e( 'Import settings','fdp-migr' ); ?></span></p>
				<?php } ?>
				<input id="fdp-migr-import-input" type="file" id="file" style="display:none" />
				
				<a href="#" style="display:none" id="fdp-migr-export-hidden" class="button"><?php esc_html_e( 'Download Options','fdp-migr' ); ?></a>
			
			</div>
			<div id="fdp-success" class="eos-dp-notice notice notice-success eos-hidden" style="padding:10px"><?php esc_html_e( 'Done!','eos-dp-pro' ); ?></div>
			<div id="fdp-fail" class="eos-dp-notice notice notice-error eos-hidden" style="padding:10px" data-default_msg="<?php esc_attr_e( 'Something went wrong!','eos-dp-pro' ); ?>"></div>
		</div>
	</section>
	<?php
	wp_nonce_field( 'fdp_migr_export_nonce','fdp_migr_export_nonce' );
	wp_nonce_field( 'fdp_migr_import_nonce','fdp_migr_import_nonce' );
	wp_enqueue_script( 'fdp-pro-migration',EOS_DP_PRO_PLUGIN_URL.'/admin/js/fdp-pro-migration.js',array(),true );
	wp_localize_script( 'fdp-pro-migration','fdp_migr_js',array( 'ajaxurl' => admin_url( 'admin-ajax.php' ),'blog_name' => sanitize_title( get_bloginfo('name' ) ),'upload_dir' => esc_url( $upload_dir['baseurl'] ) ) );
}
