<?php
defined( 'ABSPATH' ) || exit; // Exit if accessed directly

//Logged settings callback
function eos_dp_pro_logged_callback(){
  if( apply_filters( 'fdp_hide_logged_page',( !current_user_can( 'activate_plugins' ) && !current_user_can( 'fdp_plugins_viewer' ) && !defined( 'FDP_EMERGENCY_LOG_ADMIN' ) ) ) ){
    eos_dp_navigation();
  ?>
		<h2><?php esc_html_e( 'Sorry, you have not the right for this page','eos-dp' ); ?></h2>
		<?php
		return;
	}
  wp_enqueue_script( 'eos-dp-pro-logged',EOS_DP_PRO_PLUGIN_URL.'/admin/js/eos-dp-pro-logged-1.0.0.js',array( 'jquery' ),EOS_DP_PRO_VERSION,true );
  wp_enqueue_script( 'fdp-settings',EOS_DP_SETTINGS_JS_URL,array(),true );
	wp_localize_script( 'fdp-settings','fdp_setts_js',array( 'ajaxurl' => admin_url( 'admin-ajax.php' ),'action' => 'eos_dp_pro_save_settings','opts_key' => 'eos_dp_logged_conditions' ) );
	$active_plugins = eos_dp_active_plugins();
	$n = count( $active_plugins );
	$opts = eos_dp_pro_get_option( 'eos_dp_pro_main' );
	if( $opts && isset( $opts['eos_dp_logged_conditions'] ) ){
		$opts = $opts['eos_dp_logged_conditions'];
		$opts[] = '{"value" : "","plugins" : ";"}';
	}
	else{
		$opts = array( 0 => '{"value" : "","plugins" : ";"}' );
	}
  $users_metas = array();
  $user_metas = array();
  $users = array();
	$condsN = count( $opts );
	$dropdown_roles = $dropdown_capabilities = $dropdown_users_metas = '';
	global $wp_roles;
	$all_capabilities = array();
	if( $wp_roles && is_object( $wp_roles ) ){
			$dropdown_roles = '<select class="eos-dp-pro-roles eos-dp-pro-button-input">';
			$dropdown_capabilities = '<select class="eos-dp-pro-capabilities eos-dp-pro-button-input">';
			foreach( $wp_roles->roles as $role_slug => $arr ){
        $users_by_role = get_users( array( 'role__in' => array( $role_slug ) ) );
        if( $users_by_role && is_array( $users_by_role ) && is_object( $users_by_role[0] ) ){
          $user_id = $users_by_role[0]->ID;
          if( !in_array( $user_id,$users ) ){
            $users[] = $user_id;
          }
        }
				$dropdown_roles .= '<option value="'.esc_attr( $role_slug ).'" >'.esc_html( $arr['name'] ).'</option>';
				$all_capabilities = array_merge( $all_capabilities,$arr['capabilities'] );
			}
			$dropdown_roles .= '</select>';
			$all_capabilities = array_unique( array_keys( $all_capabilities ) );
			sort( $all_capabilities );
			foreach( $all_capabilities as $capability ){
				$dropdown_capabilities .= '<option value="'.esc_attr( $capability ).'">'.esc_html( $capability ).'</option>';
			}
			$dropdown_capabilities .= '</select>';
	}
  if( $users && !empty( $users ) ){
    foreach( $users as $user ){
      $user_metas = get_user_meta( $user,null,true );
      $users_metas = array_unique( array_merge( $users_metas,array_keys( $user_metas ) ) );
    }
  }
  if( !empty( $users_metas ) ){
    sort( $users_metas );
    $users_metas = array_unique( $users_metas );
    $dropdown_users_metas = '<p><label>'.esc_html__( 'Key','eos-dp-pro' ).'</label></p>';
    $dropdown_users_metas .= '<select id="eos-dp-pro-usermeta" class="eos-dp-pro-usermeta eos-dp-pro-button-input">';
    foreach( $users_metas as $user_meta_key ){
      $dropdown_users_metas .= '<option value="'.esc_attr( $user_meta_key ).'" >'.esc_html( $user_meta_key ).'</option>';
    }
    $dropdown_users_metas .= '</select>';
    $dropdown_users_metas .= '<div class="fdp-usermeta-radio-wrp" style="margin-top:16px">';
    $dropdown_users_metas .= '<p><label>'.esc_html__( 'Value','eos-dp-pro' ).'</label></p>';
    $dropdown_users_metas .= '<input type="radio" id="fdp-radio-usermeta-any" name="usermeta-value-choice" value="any" checked="checked" >';
    $dropdown_users_metas .= '<label for="fdp-radio-usermeta-any">'.esc_html__( 'Any','eos-dp-pro' ).'</label>  ';
    $dropdown_users_metas .= '<input type="radio" id="fdp-radio-usermeta-not_defined" name="usermeta-value-choice" value="not_defined" >';
    $dropdown_users_metas .= '<label for="fdp-radio-usermeta-not_defined">'.esc_html__( 'Not defined','eos-dp-pro' ).'</label>  ';
    $dropdown_users_metas .= '<input type="radio" id="fdp-radio-usermeta-custom" name="usermeta-value-choice" value="" />';
    $dropdown_users_metas .= '<label for="fdp-radio-usermeta-custom">'.esc_html__( 'Custom','eos-dp-pro' ).'</label>';
    $dropdown_users_metas .= '<input type="text" class="eos-dp-pro-usermeta_value eos-dp-pro-button-input eos-hidden" >';
    $dropdown_users_metas .= '</div>';
  }
	$dropdown_language = wp_dropdown_languages(
		array(
			'name' => 'eos-dp-pro-language',
			'id' => 'eos-dp-pro-language',
			'languages' => get_available_languages(),
			'show_available_translations' => true,
			'show_option_site_default' => true,
			'echo' => false
		)
	);
	$inputs = array(
		'role' => $dropdown_roles,
		'capability' => $dropdown_capabilities,
		'language' => $dropdown_language,
		'email' => '<input type="email" class="eos-dp-pro-email eos-dp-pro-button-input" />',
		'username' => '<input type="text" class="eos-dp-pro-email eos-dp-pro-button-input" />',
		'registered_before' => '<input type="date" class="eos-dp-pro-registered-before eos-dp-pro-button-input" />',
		'registered_after' => '<input type="date" class="eos-dp-pro-registered-after eos-dp-pro-button-input" />',
    'usermeta' => $dropdown_users_metas
	);
	if( class_exists( 'WooCommerce' ) ){
		$inputs['has_bought'] = '<input type="hidden" class="eos-dp-pro-has-bought eos-dp-pro-button-input" />';
	}
	wp_nonce_field( 'fdp_setts_nonce','fdp_setts_nonce' );
	eos_dp_navigation();
  $conditions = eos_dp_logged_user_conditions();
	?>
	<section id="eos-dp-by-logged-section" class="eos-dp-section">
		<div class="eos-dp-margin-top-32">
			<h2><?php esc_html_e( 'Uncheck the plugins you want to deactivate if your custom conditions are true for logged-in users.','eos-dp' ); ?></h2>
			<?php if( !class_exists( 'user_switching' ) ){ ?>
			<p><?php printf( esc_html__( 'If you want to check what other users see in the backend, try the plugin %s'),'<a href="'.admin_url( 'plugin-install.php?tab=plugin-information&plugin=user-switching' ).'" target="_blank">Switching User</a>' ); ?></p>
			<?php } ?>
			<?php do_action( 'eos_dp_before_wrapper' ); ?>
			<div id="eos-dp-wrp">
				<?php
				$row = 0;
				?>
				<table id="eos-dp-setts"  data-zoom="1">
					<tbody class="eos-dp-logged">
					<?php eos_dp_table_head();
					$plugins_by_dirs = isset( $GLOBALS['eos_dp_plugins_by_dirs'] ) ? $GLOBALS['eos_dp_plugins_by_dirs'] : eos_dp_get_plugins();
					eos_dp_plugins_slider_row();
					foreach( $opts as $e => $string ){
						if( '' === $e || false !== strpos( $e,'_off' ) || '' === $string ) continue;
						$arr = json_decode( str_replace( '\\','',sanitize_text_field( $string ) ),true );
						if( !is_array( $arr ) || !isset( $arr['value'] ) || !isset( $arr['plugins'] ) ) continue;
						$expression = $arr['value'];
						$plugins = array_unique( explode( ';',str_replace( 'pn:','',$arr['plugins'] ) ) );
						?>
						<tr id="fdp-row-<?php echo $row; ?>" class="eos-dp-logged-row eos-dp-post-row<?php echo isset( $opts['fdp-user-cond-'. $row]) ? '' : ' eos-hidden'; ?>">
							<td class="eos-dp-post-name-wrp">
	              <span class="eos-dp-not-active-wrp"><input title="<?php esc_attr__( 'Activate/deactivate all plugins in this row','eos-dp-pro' ); ?>" data-row="<?php echo esc_attr( $row ); ?>" class="eos-dp-global-chk-row" type="checkbox" /></span>
								<span class="dashicons dashicons-move" title="<?php _e( 'Move it up to assign higher priority','eos-dp' ); ?>"></span>
								<span class="hover eos-dp-edit-logged-expression dashicons dashicons-edit" title="<?php esc_attr_e( 'Edit the condition','eos-dp-pro' ); ?>"></span>
								<span class="eos-dp-delete-condition dashicons dashicons-trash hover" title="<?php esc_attr_e( 'Delete','eos-dp-pro' ); ?>"></span>
								<span class="eos-dp-plugin-visibility dashicons dashicons-admin-plugins<?php echo isset( $opts[$e.'_off'] ) && 'true' === $opts[$e.'_off'] ? ' eos-dp-off' : ''; ?>" title="<?php esc_attr_e( 'Show/hide in the page of plugins.','eos-dp-pro' ); ?>">
									<span class="hover dashicons dashicons-visibility"></span>
									<span class="dashicons dashicons-hidden"></span>
								</span>
								<input id="fdp-user-cond-<?php echo $row; ?>" class="fdp-opt" type="text" title="<?php echo esc_attr( $expression ); ?>" value="<?php echo esc_attr( $expression ); ?>" disabled />
								<a title="<?php esc_attr_e( 'Copy this row settings','eos-dp' ); ?>" class="eos-dp-copy" href="#"><span class="dashicons dashicons-admin-page"></span></a>
								<a title="<?php esc_attr_e( 'Paste last copied row settings','eos-dp' ); ?>" class="eos-dp-paste" href="#"><span class="dashicons dashicons-category"></span></a>
								<div class="eos-dp-logged-actions" style="max-height:100vh;max-height:calc(100vh - 40px);overflow-y:scroll">
									<div style="max-width:100%">
										<h2><?php esc_html_e( 'Build your custom conditions','eos-dp-pro' ); ?></h2>
										<p><?php esc_html_e( 'Example:','eos-dp-pro' ); ?></p>
										<p><?php esc_html_e( "NOT(capability(activate_plugins)) will match all users who can't activate plugins.","eos-dp-pro"); ?></p>
									</div>
                  <div style="position:sticky;background:#fff;top:-60px;z-index:9999;padding:10px 0">
                    <div class="eos-dp-margin-top-32">
  										<input type="text" style="font-size:1.2rem" class="eos-dp-logged-expression" value="<?php echo esc_html( $expression ); ?>" />
  									</div>
  	                <div class="eos-dp-operators eos-dp-margin-top-15">
  										<a class="button eos-dp-operator-or" href="#" data-expr="not( )" data-cursor_ofs="-2">NOT</a>
  										<a class="button eos-dp-operator-and" style="display:none" href="#" data-expr="or( , )" data-cursor_ofs="-4">OR</a>
  										<a class="button eos-dp-operator-not" style="display:none" href="#" data-expr="and( , )" data-cursor_ofs="-4">AND</a>
  										<a class="button eos-dp-expr-clear" href="#" data-expr="clear"><span style="padding:0;line-height:1.5" class="dashicons dashicons-editor-removeformatting"></span><?php esc_html_e( 'CLEAR','eos-dp-pro' ); ?></a>
  									</div>
                    <div class="eos-dp-btns-wrp right">
                      <a title="<?php esc_attr_e( 'Close','eos-dp-pro' ); ?>" class="hover eos-dp-close-actions button"><?php esc_html_e( 'Close','eos-dp-pro' ); ?></a>
                      <a title="<?php esc_attr_e( 'Save','eos-dp-pro' ); ?>" class="hover eos-dp-ok-actions button"><?php esc_html_e( 'Save','eos-dp-pro' ); ?></a>
                    </div>
                  </div>
									<div class="eos-dp-conditions eos-dp-margin-top-15">
	                  <?php
										foreach( $conditions as $l => $arr ){
											// echo ($l + 1)/2 === absint( ($l + 1)/2 ) ? '<br/>' : '';
											?>
											<div class="button" style="display:block;margin-bottom:12px;position:relative">
												<span id="eos-dp-condition-<?php echo $l; ?>" class="eos-dp-condition eos-dp-condition-<?php echo $arr[0]; ?>"><span class="dashicons dashicons-<?php echo $arr[1]; ?>"></span><?php esc_html_e( $arr[2],'eos-dp-pro' ); ?>
													<br/>
													<?php echo isset( $inputs[$arr[0]] ) ? $inputs[$arr[0]] : ''; ?>
												</span>
												<span class="hover eos-dp-add-condition dashicons dashicons-plus-alt" data-expr="<?php echo $arr[0]; ?>()" data-cursor_ofs="1"></span>
											</div>
	                <?php } ?>
	                </div>
	              </div>
							</td>
							<?php
							$k = 0;
							foreach( $active_plugins as $plugin ){
								if( in_array( $plugin,array_keys( $plugins_by_dirs ) ) ){
									$extra_class = $plugin === EOS_DP_PLUGIN_BASE_NAME ? ' eos-hidden' : '';
									?>
									<td class="center<?php echo !in_array( $plugin,$plugins ) ? ' eos-dp-active' : '';echo $extra_class; ?>" data-path="<?php echo esc_attr( $plugin ); ?>">
										<div class="eos-dp-td-chk-wrp eos-dp-td-logged-chk-wrp">
											<input class="eos-dp-row-<?php echo $row; ?> eos-dp-col-<?php echo $k + 1; ?> eos-dp-col-<?php echo ( $k + 1 ); ?>" data-checked="<?php echo in_array( $plugin,$plugins ) ? 'checked' : 'not-checked'; ?>" type="checkbox"<?php echo in_array( $plugin,$plugins ) ? ' checked' : ''; ?> />
										</div>
									</td>
									<?php
									++$k;
								}
							}
							?>
						</tr>
						<?php
						++$row;
						}
						?>
						<tr><td colspan="<?php echo $n + 1; ?>" style="border:none;padding:0"><button id="fdp-add-conditions-row" class="button" style="margin-top:16px"><?php esc_html_e( 'Add row','eos-dp-pro' ); ?></button></td></tr>
					</tbody>
				</table>
			</div>
		</div>
		<?php
		if( current_user_can( 'activate_plugins' ) ){
			eos_dp_save_button();
		}
		?>
		<div id="eos-dp-overlap"></div>
	</section>
	<?php
}
