<?php
defined( 'ABSPATH' ) || exit; // Exit if accessed directly

//It adds the testing section
function eos_dp_pro_testing_callback(){
	wp_nonce_field( 'eos_dp_testing', 'eos_dp_testing' );
	eos_dp_navigation();
	$dpOpts = eos_dp_pro_get_option( 'fdp_pro_admin' );
	$locations = eos_dp_pro_gtmetrix_locations();
	$n = 0;
	?>
	<section id="eos-dp-testing-section" class="eos-dp-section">
		<div id="eos-dp-apis-wrp">
			<h2 class="left"><span class="eos-dp-gtmetrix-icon"></span><?php _e( 'GTmetrix','eos-dp-pro' ); ?></h2>
			<table id="eos-dp-gtmetrix-apis">
				<tr id="eos-dp-gt-table-head">
					<th><?php _e( 'Account Email','eos-dp-pro' ); ?></label></th>
					<td>
						<input id="eos-dp-gt-user-email" type="email" style="min-width:400px" value="<?php echo isset( $dpOpts['gtmetrix_email'] ) ? esc_attr( $dpOpts['gtmetrix_email'] ) : ''; ?>" />
					</td>
				</tr>
				<tr id="eos-dp-gt-table-head">
					<th><?php _e( 'API Key','eos-dp-pro' ); ?></label></th>
					<td>
						<input id="eos-dp-gt-api-key" type="text" style="min-width:400px" value="<?php echo isset( $dpOpts['gtmetrix_api'] ) ? esc_attr( $dpOpts['gtmetrix_api'] ) : ''; ?>"/>
					</td>
				</tr>
				<tr id="eos-dp-gt-table-head">
					<th><?php _e( 'Testing Location','eos-dp-pro' ); ?></th>
					<td>
						<select id="eos-dp-gt-location" style="min-width:400px">
						<?php foreach( $locations as $location ){ ?>
							<option <?php echo isset( $dpOpts['gtmetrix_location_id'] ) && $n === absint( $dpOpts['gtmetrix_location_id'] ) ? 'selected ' : ''; ?>value="<?php echo $n; ?>"><?php echo esc_html( $location ); ?></option>
						<?php ++$n; } ?>
						</select>
					</td>
				</tr>
			</table>
		</div>
		<div id="eos-dp-psi-wrp" style="margin-top:64px">
			<h2 class="left"><span class="eos-dp-gpsi-icon"></span><?php _e( 'Google Page Speed Insights','eos-dp-pro' ); ?></h2>
			<table id="eos-dp-psi-apis">
				<tr id="eos-dp-gt-table-head">
					<th><?php _e( 'Api Key','eos-dp-pro' ); ?></th>
					<td>
						<input id="eos-dp-gpsi-api-key" type="text" style="min-width:400px" value="<?php echo isset( $dpOpts['gpsi_api'] ) ? esc_attr( $dpOpts['gpsi_api'] ) : ''; ?>"/>
					</td>
				</tr>
			</table>
		</div>
	</section>
	<?php eos_dp_save_button();
}
