jQuery(document).ready(function($){
  fdp_styles_media = [],media = '',id = '';
  var global_assets_iframe_wrp = document.getElementById('fdp-assets-global-view-iframe-wrp'),global_assets_iframe = document.getElementById('fdp-assets-global-view-iframe');
  $('style,link').each(function(){
    media = $(this).attr('media');
    id = $(this).attr('id');
    if(id && 'undefined' !== id){
      fdp_styles_media[id] = 'undefined' !== typeof(media) ? media : 'all';
    }
  });
  fdp_styles_media['default'] = 'all';
  $('#fdp-close-assets-iframe').on('click',function(){
    global_assets_iframe_wrp.className = 'eos-hidden';
  });
  $('#fdp-assets-filter-global-view a').on('click',function(){
    var button = $('#fdp-assets-filter-global-view');
    button.addClass('eos-dp-progress');
    global_assets_iframe.src = global_assets_iframe.dataset.src;
    $('#fdp-assets-filter-global-view').css('background-position','center center');
    $(global_assets_iframe).on('load',function(){
      $('#fdp-assets-filter-global-view').css('background-position','-9999px -9999px');
      global_assets_iframe_wrp.className = '';
      button.removeClass('eos-dp-progress');
    });
    return false;
  });
  $('.fdp-asset-remove-toggle').on('click',function(){
    var asset = $(this).closest('.fdp-asset'),media = 'all',id = asset.attr('data-id');
    asset.toggleClass('fdp-active').removeClass('fdp-warning');
    if('styles' === asset.attr('data-asset')){
      id = id && '' !== id ? id + '-css' : 'default';
      media = !asset.hasClass('fdp-active') ? 'none' : fdp_styles_media[id];
      $('#' + id).attr('media',media);
    }
    asset.find('[data-where-type="single"]').toggleClass('fdp-button-active');
  });
  $('[data-where-type="single"]').on('click',function(){
    $(this).closest('.fdp-asset').toggleClass('fdp-active');

  });
  $('.fdp-asset-plugins-sel').on('change',function(){
    if('void' === $(this).val()) return false;
    if('all' === $(this).val()){
      $('[data-from-type="plugin"]').removeClass('fdp-hidden');
    }
    else{
      $('.fdp-asset').addClass('fdp-hidden');
      if('active' === $(this).val()){
        $('.fdp-plugin-active').removeClass('fdp-hidden');
      }
      else if('disabled' === $(this).val()){
        $('.fdp-plugin-disabled').removeClass('fdp-hidden');
      }
      else{
        $('[data-from="' + $(this).val() + '"]').removeClass('fdp-hidden');
      }
    }
  });
  $('.fdp-asset-edit-section .fdp-button').on('click',function(){
    $(this).toggleClass('fdp-button-active');
  });
  $('.fdp-assets-filter').on('click',function(){
    var button = $(this),type = button.attr('data-filter');
    $('.fdp-asset-plugins-sel').val('all').trigger('change');
    $('.fdp-assets-filter').removeClass('fdp-button-active');
    button.addClass('fdp-button-active');
    if('all' !== type){
      $('.fdp-asset').addClass('fdp-hidden');
      $('[data-from-type="' + type + '"]').removeClass('fdp-hidden');
      if('plugin' !== type){
        $('.fdp-asset-plugins-sel').addClass('fdp-hidden');
      }
      else{
        $('.fdp-asset-plugins-sel').removeClass('fdp-hidden');
      }
    }
    else{
      $('.fdp-asset-plugins-sel').removeClass('fdp-hidden');
      $('.fdp-asset').removeClass('fdp-hidden');
    }
  });
  $('#fdp-assets-reset-show').on('click',function(){
    $('#fdp-reset-msg-wrp').removeClass('eos-hidden');
  });
  $('#fdp-assets-reset').on('click',function(){
    var btn = $(this),success_msg = $('#fdp-message-success'),error_msg = $('#fdp-message-error');
    btn.addClass('eos-dp-progress');
    $.ajax({
      type : "POST",
      url : fdp_assets.ajaxurl,
      data : {
        "asset" : fdp_assets.asset,
        "nonce" : $('#fdp-reset-assets').val(),
        "action" : "eos_dp_pro_reset_assets"
      },
      success : function(response){
        if('' === response){
          error_msg.removeClass('fdp-hidden');
        }
        else{
          global_assets_iframe.src = global_assets_iframe.dataset.src;
          success_msg.removeClass('fdp-hidden');
        }
        setTimeout(function(){
          $('.fdp-message').addClass('fdp-hidden');
          window.location.href = window.location.href;
        },1000);
        $('#fdp-reset-msg-wrp').addClass('eos-hidden');
        btn.removeClass('eos-dp-progress');
      }
    });
  });
  $('.fdp-move-sidebar').on('click',function(){
    $('#fdp-assets-main-wrp').toggleClass('fdp-sidebar-close');
  });
  $('.fdp-close-popup').on('click',function(){
    var asset = $(this).closest('.fdp-asset'),button = asset.find('.' + $(this).attr('data-button')),single_button = asset.find('[data-where-type="single"]'),media = 'all',id = asset.attr('data-id');
    if(single_button.hasClass('fdp-button-active')){
      asset.addClass('fdp-active');
    }
    else{
      asset.removeClass('fdp-active');
    }
    if('styles' === asset.attr('data-asset')){
      id = id && '' !== id ? id + '-css' : 'default';
      media = !asset.hasClass('fdp-active') ? 'none' : fdp_styles_media[id];
      $('#' + id).attr('media',media);
    }
    button.trigger('click');
  });
  $('.fdp-assets-head-button').on('click',function(){
    var asset = $(this).closest('.fdp-in-head');
    asset.removeClass('fdp-in-head').addClass('fdp-in-footer');
    if(!asset.hasClass(asset.attr('data-position'))){
      asset.find('.fdp-assets-footer-button').addClass('fdp-open');
    }
    else{
      asset.find('.fdp-assets-footer-button').removeClass('fdp-open');
    }
  });
  $('.fdp-assets-footer-button').on('click',function(){
    var asset = $(this).closest('.fdp-in-footer');
    asset.removeClass('fdp-in-footer').addClass('fdp-in-head');
    if(!asset.hasClass(asset.attr('data-position'))){
      asset.find('.fdp-assets-head-button').addClass('fdp-open');
    }
    else{
      asset.find('.fdp-assets-head-button').removeClass('fdp-open');
    }
  });
  $('.fdp-assets-edit-button').on('click',function(){
    var info = $(this).closest('.fdp-asset').find('.fdp-assets-edit');
    $('.fdp-assets-edit').not(info).addClass('fdp-hidden');
    info.toggleClass('fdp-hidden');
    $('body').toggleClass('fdp-popup-open');
  });
  $('.fdp-asset-actions .dashicons').not('.fdp-assets-restore-css-button').not('.fdp-assets-reduce-css-button').on('click',function(){
    var button = $(this);
    if('undefined' !== typeof(button.attr('href'))) return;
    button.toggleClass('fdp-open');
    if(button.hasClass('dashicons-hidden')){
      button.closest('.fdp-asset').find('.dashicons-visibility').removeClass('fdp-open');
    }
    else if(button.hasClass('dashicons-visibility')){
      button.closest('.fdp-asset').find('.dashicons-hidden').addClass('fdp-open');
    }
  });
  $('#fdp-assets-filter-scripts').on('click',function(){
    window.location.href = window.location.href.replace('fdp-assets=styles','fdp-assets=scripts').split('&t=')[0] + '&t=' + Date.now();
  });
  $('#fdp-assets-filter-styles').on('click',function(){
    window.location.href = window.location.href.replace('fdp-assets=scripts','fdp-assets=styles').split('&t=')[0] + '&t=' + Date.now();
  });
  $('#fdp-assets-filter-close').on('click',function(){
    window.location.href = window.location.href.replace('?fdp-assets=scripts','').replace('?fdp-assets=styles','').split('&t=')[0];
  });
  $('.fdp-assets-reset-button').on('click',function(){
    var button = $(this);
    button.closest('.fdp-asset').removeClass('fdp-in-footer').removeClass('fdp-in-head').addClass(button.attr('data-position-original'));
  });
  $('.fdp-assets-restore-css-button').on('click',function(){
    var button = $(this),asset = button.closest('.fdp-asset'),size_wrp = asset.find('.fdp-asset-style-size'),original_src = asset.attr('data-original-src');
    $('#' + asset.attr('data-id') + '-css').attr('href',original_src);
    asset.removeClass('fdp-reduced-style');
    asset.find('.fdp-asset-file-link').attr('href',original_src);
    asset.find('.fdp-asset-style-src').text(original_src).attr('href',original_src);
    asset.find('iframe').attr('src',original_src);
    asset.find('.fdp-assets-reduce-css-button').removeClass('fdp-hidden').toggleClass('fdp-open');
    size_wrp.text(size_wrp.attr('data-size'));
    button.addClass('fdp-hidden').toggleClass('fdp-open');
  });
  $('.fdp-assets-reduce-css-button').on('click',function(){
    var button = $(this),asset = button.closest('.fdp-asset');
    fdp_pro_reduce_style(asset.attr('data-id'),button);
    asset.find('.fdp-assets-restore-css-button').toggleClass('fdp-open');
    button.toggleClass('fdp-open');
  });
  $('[data-where-type="post_types"]').on('click',function(){
    var button = $(this);
    if(fdp_assets.post_type === button.attr('data-where') && !$(this).hasClass('fdp-button-active')){
      button.closest('.fdp-assets-edit').find('[data-where-type="single"]').removeClass('fdp-button-active');
    }
  });
  $('.fdp-assets-save,#fdp-prevew-assets').on('click',function(){
    var btn = $(this),plugin_path = '',
      assets = {},
      assets_active = {},
      custom_urls = {},
      singles_active = [],
      assets_moved_to_footer = [],
      assets_moved_to_head = [],
      reduced_styles = [],
      action_id = btn.attr('data-action-id'),
      success_msg = $('#fdp-message-success'),
      error_msg = $('#fdp-message-error');
    btn.addClass('eos-dp-progress');
    success_msg.addClass('fdp-hidden');
    error_msg.addClass('fdp-hidden');
    $('.fdp-assets-reduce-css-button').each(function(){
      if($(this).hasClass('fdp-open')){
        reduced_styles.push($(this).closest('.fdp-asset').attr('data-id'));
      }
    });
    $('.fdp-asset').each(function(){
      var asset = $(this),asset_id = asset.attr('data-id'),position = asset.attr('data-position');
      if(asset.hasClass('fdp-in-head') && 'fdp-in-footer' === position){
        assets_moved_to_head.push(asset.attr('data-id'));
      }
      if(asset.hasClass('fdp-in-footer') && 'fdp-in-head' === position){
        assets_moved_to_footer.push(asset_id);
      }
      if(asset.find('[data-where-type="single"]').hasClass('fdp-button-active') && !asset.find('[data-where-type="post_types"][data-where="page"]').hasClass('fdp-button-active')){
        singles_active.push(asset_id);
      }
      $('.fdp-asset-edit-section .fdp-button').each(function(){
        var button = $(this),where_type = button.attr('data-where-type'),where = button.attr('data-where'),asset = button.closest('.fdp-assets-edit').attr('data-asset');
        if(!$(this).hasClass('fdp-button-active')){
          if('undefined' === typeof(assets[asset])) assets[asset] = {};
          if('undefined' === typeof(assets[asset][where_type])) assets[asset][where_type] = '';
          if('single' !== where_type && -1 === assets[asset][where_type].indexOf(where + ',')){
            assets[asset][where_type] = assets[asset][where_type] + where + ',';
          }
        }
        else{
          if('undefined' === typeof(assets_active[asset])) assets_active[asset] = {};
          if('undefined' === typeof(assets_active[asset][where_type])) assets_active[asset][where_type] = '';
          if(-1 === assets_active[asset][where_type].indexOf(where + ',')) {
            assets_active[asset][where_type] = assets_active[asset][where_type] + where + ',';
          }
        }
      });
    });
    $('[data-where="' + fdp_assets.post_id + '"').each(function(){
      var single = $(this);
      if(single.closest('.fdp-assets-edit').find('[data-where-type="post_types"][data-where="' + fdp_assets.post_type + '"').hasClass('fdp-button-active') && !single.hasClass('fdp-button-active')){
        var asset = single.closest('.fdp-assets-edit').attr('data-asset');
        assets[asset]['single'] = assets[asset]['single'] + fdp_assets.post_id + ',';
      }
    });
    $('.fdp-asset-custom-url-input').each(function(){
      var input = $(this);
      if('' !== input.val()){
        var asset_input = input.closest('.fdp-assets-edit');
        if('undefined' === typeof(custom_urls[asset_input.attr('data-asset')])){
          custom_urls[asset_input.attr('data-asset')] = '';
        }
        custom_urls[asset_input.attr('data-asset')] = custom_urls[asset_input.attr('data-asset')] + input.val();
      }
    });
    $.ajax({
			type : "POST",
			url : fdp_assets.ajaxurl,
			data : {
				"post_id" : fdp_assets.post_id,
        "asset" : fdp_assets.asset,
        "assets" : JSON.stringify(assets),
        "singles_active" : JSON.stringify(singles_active),
        "assets_active" : JSON.stringify(assets_active),
        "custom_urls" : JSON.stringify(custom_urls),
        "moved_to_head" : assets_moved_to_head.join(','),
        "moved_to_footer" : assets_moved_to_footer.join(','),
        "reduced_styles" : reduced_styles.join(','),
        "nonce" : $('#' + btn.attr('data-nonce')).val(),
        "action_id" : action_id,
				"action" : btn.attr('data-action')
			},
			success : function(response){
				if('' === response){
					error_msg.removeClass('fdp-hidden');
				}
        else{
          if('1' === response){
            global_assets_iframe.src = global_assets_iframe.dataset.src;
            success_msg.removeClass('fdp-hidden');
          }
          else if('preview' === response){
            window.open(window.location.href + '&preview=true&action_id=' + action_id,'action_id');
          }
        }
        setTimeout(function(){
          $('.fdp-message').addClass('fdp-hidden');
        },10000);
        btn.removeClass('eos-dp-progress');
			}
		});
  });
  $('#fdp-plugins-wrp .fdp-asset').on('click',function(){
    var plugins = {},plugins_cookie = eos_dp_pro_get_cookie('fdp_live'),plugins_post = [];

    $('#fdp-plugins-wrp .fdp-asset').each(function(){
      plugins_post.push(this.dataset.path);
    });
    plugins[fdp_assets.post_id] = plugins_post;
    console.log(plugins);
    eos_dp_pro_set_cookie('fdp_live',JSON.stringify(plugins),2);
  });
});
function fdp_pro_reduce_style(css_id,button){
  button.addClass('eos-dp-progress');
  var asset = jQuery('.fdp-asset[data-id="' + css_id + '"]'),url = asset.attr('data-original-src');
    var css = jQuery.get(url,function(data){
      if(data && '' !== data){
        button.removeClass('eos-dp-progress');
        fdp_pro_save_reduced_css(css_id,fdp_assets.post_id,fdp_pro_reduce_css(data),button);
      }
  });
}
function fdp_pro_reduce_css(css){
	jQuery('body').addClass('eos-compressing-css');
	css = css.replace(/\{ /g,'{');
	css = css.replace(/; /g,';');
	css = css.replace(/ \} /g,'}');
	css = css.replace(/ \{ /g,'{');
	css = css.replace(/ \{/g,'{');
	css = css.replace(/, /g,',');
	css = css.replace(/\/\*(?:(?!\*\/)[\s\S])*\*\/|[\r\n\t]+/g,'');
	var initial_length = css.length,
	excludes = [
		'.no-script',
		'.loading',
		'.fixedmenu',
		'.normal',
		'.toggled-on',
		'.toggle-on',
		'.toggled-off',
		'.toggle-off',
		':before',
		':after',
		':selection'
	],
	cssArr = css.split(/\{([^}]+)\}/).filter(function(element, index, array){return (index % 2 === 0);});
	cssObj = [],
	style = '',
	styleStart = 0,
	cursor = '',
	kk = 0,
	k = 0,
	reduced = '',
	exclude = false,
	stripArr = [],
	stripped = '',
	sel = '';
	for(var i = 0;i < cssArr.length - 1;++i){
		try {
			if(cssArr[i].indexOf('@media') < 0 && cssArr[i].indexOf('.eos-large-menu') < 0){
				styleStart = 0;
				cursor = '';
				styleStart = css.indexOf('}' + cssArr[i] + '{',kk - 1) + cssArr[i].length + 1;
				k = 0;
				while(k < 1000 && cursor !== '}'){
					cursor = css.substring(styleStart + k,styleStart + k + 1);
					++k;
				}
				style = css.substring(styleStart,styleStart + k);
				reduced = cssArr[i];
				var arr = reduced.split(','),
					strip = false;
				if(jQuery(reduced).length < 1){
					strip = true;
				}
				else{
					for(var m = 0;m < arr.length;++m){
						if(jQuery(arr[m]).length < 1){
							sel = arr[m];
							reduced = reduced.split(',' + sel + ',').join(',');
							strip = true;
						}
					}
				}
				for(var e = 0;e < excludes.length;++e){
					if(cssArr[i].indexOf(excludes[e]) > -1){
						strip = false;
					}
				}
				if(strip){
					stripArr.push({full: cssArr[i],reduced: reduced,style: style});
				}
				kk += cssArr[i].length + style.length;
			}
		}
		catch(err) {}
	}
	for(var n = 0;n < stripArr.length;++n){
		if(stripArr[n].full !== stripArr[n].reduced){
			css = css.replace('}' + stripArr[n].full + stripArr[n].style,'}' + stripArr[n].reduced + stripArr[n].style);
		}
	}
	for(var n = 0;n < stripArr.length;++n){
		if(jQuery(stripArr[n].reduced).length < 1){
			css = css.replace('}' + stripArr[n].full + stripArr[n].style,'}');
		}

	}
	jQuery('body').removeClass('eos-compressing-css');
	return css;
}
function fdp_pro_save_reduced_css(css_id,post_id,css,button){
  button.addClass('eos-dp-progress');
  var stylesheet = jQuery('#' + css_id + '-css'),asset = button.closest('.fdp-asset');;
  if('undefined' !== typeof(stylesheet.attr('data-reduced-href'))){
    var reduced_src = stylesheet.attr('data-reduced-href'),size_wrp = asset.find('.fdp-asset-style-size');
    stylesheet.attr('href',reduced_src);
    asset.addClass('fdp-reduced-style');
    asset.find('.fdp-assets-restore-css-button').removeClass('fdp-hidden');
    asset.find('.fdp-asset-file-link').attr('href',reduced_src);
    asset.find('.fdp-asset-style-src').text(reduced_src);
    eos_dp_pro_assign_file_size(size_wrp,reduced_src);
    button.addClass('fdp-hidden').removeClass('eos-dp-progress');
  }
  else{
  	if(post_id && parseInt(post_id) > 0){
  		jQuery.ajax({
  			type : "POST",
  			url : fdp_assets.ajaxurl,
  			data : {
  				"nonce" : jQuery("#fdp_pro_reduce_css").val(),
  				"post_id" : fdp_assets.post_id,
  				"css_id" : css_id,
  				"css" : css,
  				"action" : "eos_dp_pro_save_clean_css"
  			},
  			success : function (response) {
  				if(response !== '0' && response.indexOf('http') > -1){
            stylesheet.attr('href',response);
            stylesheet.attr('data-reduced-href',response);
            button.removeClass('eos-dp-progress').addClass('fdp-hidden');
            asset.addClass('fdp-reduced-style');
            asset.find('.fdp-assets-restore-css-button').removeClass('fdp-hidden');
            asset.attr('data-src',response);
            asset.find('.fdp-asset-file-link').attr('href',response);
            asset.find('.fdp-asset-style-src').text(response);
            var size_wrp = asset.find('.fdp-asset-style-size');
            eos_dp_pro_assign_file_size(size_wrp,response);
            size_wrp.attr('data-size',size_wrp.text());
  				}
  			}
  		});
  	}
    else{
      asset.addClass('fdp-reduced-style');
      asset.find('.fdp-assets-restore-css-button').removeClass('fdp-hidden');
      button.removeClass('eos-dp-progress').addClass('fdp-hidden');
    }
  }
}
function eos_dp_pro_get_cookie(cname) {
  var cname = cname.charAt(cname.length - 1) === '*' ? cname.replace('*','') : cname + "=",
    ca = document.cookie.split(';');
  for (var i = 0; i < ca.length; i++) {
    var c = ca[i];
    while (c.charAt(0) == ' ') {
      c = c.substring(1);
    }
    if (c.indexOf(cname) > -1) {
      ca = c.split('=');
      return 'undefined' !== typeof(ca[0]) ? ca[1] : '';
    }
  }
  return "";
}
function eos_dp_pro_set_cookie(e, s, o) {
    var t, n;
    o ? ((t = new Date).setTime(t.getTime() + 24 * o * 60 * 60 * 1e3),
    n = "; expires=" + t.toGMTString()) : n = "",
    document.cookie = e + "=" + s + n + "; path=/"
}
function eos_dp_pro_assign_file_size(el,url){
  jQuery.ajax({
    type : "POST",
    url : fdp_assets.ajaxurl,
    data : {
      "nonce" : jQuery("#fdp_pro_reduce_css").val(),
      "url" : url,
      "action" : "eos_dp_pro_get_file_size"
    },
    success : function(size){
      if(size){
        el.text(size);
      }
    }
  });
}
function eos_dp_pro_computed_style_score(){
  var score = '',body = document.getElementsByTagName('body'),els = body[0].getElementsByTagName('*'),computedStyle,properties = Object.keys(body[0].style);
  for(p in properties){
    for(n in els){
      if('undefined' !== typeof(els[n].style)){
        score += window.getComputedStyle(els[n]).getPropertyValue(properties[p]);
      }
    }
  }
  return score.length;
}
