jQuery( function($){
	$('.fdp-function-string').on('click',function(e){
		$(this).closest('td').toggleClass('fdp-hook-removed');
		$(this).closest('td').toggleClass('fdp-hook-active');
	});
	$('.fdp-save-ul').on('click',function(){
		$('.fdp-overlap').hide();
		$('.fdp-hook').removeClass('fdp-active');
		var btn = $(this),
		 	removed_hooks = {},
			hook = $(this).closest('.fdp-hook'),
			counter = hook.find('.fdp-hook-count'),
			saved_count = counter.attr('data-count'),
			removed = hook.find('.fdp-hook-removed').length;
		counter.text('(' + (parseInt(saved_count) - removed) + ')');
		btn.addClass('eos-dp-progress');
		fdp_update_hooks_counters();
		$('.fdp-hook-removed').each(function(){
			var removed_hook = $(this),
				hook_function = removed_hook.find('.fdp-function-string'),
				hook_function_name = hook_function.text().replace( /[\r\n]+/gm,"").replace(/\s/g,''),
				hook_priority = hook_function.attr('data-priority'),
				hook_name = hook_function.attr('data-hook_name');
			if('undefined' === typeof(removed_hooks[hook_name])){
				removed_hooks[hook_name] = [];
			}
			removed_hooks[hook_name].push([hook_function_name,hook_priority,fdp_hooks.post_id]);
		});
		$.ajax({
			type : "POST",
			url : fdp_hooks.ajaxurl,
			data : {
				"nonce" : $('#fdp-save-hooks').val(),
				"post_id" : fdp_hooks.post_id,
				"removed_hooks" : JSON.stringify(removed_hooks),
				"action" : "eos_dp_pro_save_hooks"
			},
			success : function (response) {
				if('' !== response){


				}
				btn.removeClass('eos-dp-progress');
			}
		});
	});
	$('.fdp-close-ul').on('click',function(){
		$('.fdp-overlap').hide();
		$('.fdp-hook').removeClass('fdp-active');
	});
	$('.fdp-activate-all-ul').on('click',function(){
		$(this).closest('.fdp-hook-dropdown').find('.fdp-hook-removed').removeClass('fdp-hook-removed').addClass('fdp-hook-active');
	});
	$('.fdp-disable-all-ul').on('click',function(){
		$(this).closest('.fdp-hook-dropdown').find('.fdp-hook-active').removeClass('fdp-hook-active').addClass('fdp-hook-removed');
	});
	$('.fdp-overlap').on('click',function(e){
		if('a' === e.target.tagName.toLowerCase()){
			var win = window.open(e.target.href,'_blank');
			win.focus();
		}
		return false;
	});
	$('.fdp-hook').on('click',function(){
		$('.fdp-overlap').hide();
		$(this).find('.fdp-overlap').show();
		$('.fdp-hook').not($(this)).removeClass('fdp-active');
		$(this).toggleClass('fdp-active');
	});
	$('#fdp-show-actions').on('click',function(){
		$('body').toggleClass('fdp-hide-actions');
		$(this).toggleClass('fdp-button-active');
	});
	$('#fdp-show-empty').on('click',function(){
		$('body').toggleClass('fdp-show-empty');
		$(this).toggleClass('fdp-button-active');
	});
	$('#fdp-show-filters').on('click',function(){
		$('.fdp-nested-hooks-block').toggleClass('fdp-active');
		$(this).toggleClass('fdp-button-active');
	});
	$('#fdp-close-hooks-popup').on('click',function(){
		$('.fdp-nested-hooks-block').removeClass('fdp-active');
		$('#fdp-show-filters').removeClass('fdp-button-active');
	});
	$('.fdp-filter-hook-row-all').on('click',function(){
		$('.fdp-hook-row').removeClass('eos-hidden');
	});
	$('.fdp-filter-hook-row').on('click',function(){
		$('.fdp-hook-row').addClass('eos-hidden');
		$('.fdp-hook-row-' + this.dataset.row.replace('theme','child-theme,.fdp-hook-row-theme').replace('plugin','plugin,.fdp-hook-row-mu-plugin')).removeClass('eos-hidden');
	});
});
function fdp_update_hooks_counters(){
	jQuery('.fdp-hook-count').each(function(){
		var actual_count = jQuery(this).text().split('(').join('').split(')').join('').replace(' ',''),
			saved_count = jQuery(this).attr('data-count');
		if(parseInt(actual_count) !== parseInt(saved_count)){
			jQuery(this).addClass('fdp-removed-functions');
		}
		else{
			jQuery(this).removeClass('fdp-removed-functions');
		}
	});
}
