<?php
/*
Plugin Name: Freesoul Deactivate Plugins PRO
Description: Freesoul Deactivate Plugins PRO adds premium features to Freesoul Deactivate Plugins.
Author: پرشین اسکریپت
Author URI: https://www.persianscript.ir
Text Domain: eos-dp-pro
Domain Path: /languages/
Version: 1.1.0.6
Requires Plugins: freesoul-deactivate-plugins
*/
/*  Copyright 2023 Freesoul Deactivate Plugins (email: info at freesoul-deactivate-plugins.com)
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
*/
defined( 'ABSPATH' ) || exit; // Exit if accessed directly.

//The plugiin desn't run if constants defined
if( !is_admin() && defined( 'FDP_PRO_EXCLUDE_FRONT' ) && FDP_PRO_EXCLUDE_FRONT && isset( $_GET[FDP_PRO_EXCLUDE_FRONT] ) && 'true' === $_GET[FDP_PRO_EXCLUDE_FRONT] ) return;
if( is_admin() && defined( 'FDP_PRO_EXCLUDE_BACK' ) && FDP_PRO_EXCLUDE_BACK && isset( $_GET[FDP_PRO_EXCLUDE_BACK] ) && 'true' === $_GET[FDP_PRO_EXCLUDE_BACK] ) return;

//Definitions
define( 'EOS_DP_PRO_VERSION','1.1.0.6' );
define( 'FDP_PRO_ACTIVE',true );
define( 'EOS_DP_PRO_NEED_UPDATE_MU',false );
define( 'EOS_DP_PRO_PLUGIN_DIR', untrailingslashit( dirname( __FILE__ ) ) );
define( 'EOS_DP_PRO_PLUGINS_DIR', untrailingslashit( dirname( __DIR__ ) ) );
define( 'EOS_DP_PRO_PLUGIN_URL', untrailingslashit( plugins_url( '', __FILE__ ) ) );
define( 'EOS_DP_PRO_PLUGINS_URL',dirname( EOS_DP_PRO_PLUGIN_URL ) );
define( 'EOS_DP_PRO_PLUGIN_BASE_NAME', untrailingslashit( plugin_basename( __FILE__ ) ) );
define( 'EOS_DP_PRO_PLUGIN_FILE', __FILE__  );
define( 'EOS_DP_PRO_FDP_MIN_VERSION', '2.1.7'  );
define( 'FDP_PRO_LICENSE_EDD', false  );

add_action( 'wp_footer',function(){
	if( defined( 'FDP_DEV_MODE' ) && false !== FDP_DEV_MODE ){
		?>
		<script id="fdp-dev-mode">
		function fdp_dev_mode(){
			var a = document.getElementsByTagName('a'),n=0,dev = "<?php echo esc_js( FDP_DEV_MODE ); ?>";
			for(n;n<a.length;++n){
				a[n].href += a[n].href.indexOf('?') > 0 ? '&fdp-dev=' + dev : '?fdp-dev=' + dev;
			}
		}
		fdp_dev_mode();
		</script>
		<?php
	}
} );

if( defined( 'FDP_OFF' ) && FDP_OFF ) return;

if( !defined( 'EOS_DP_MU_VERSION' ) ){
	require_once EOS_DP_PRO_PLUGIN_DIR.'/inc/fdp-not-active.php';
	return;
}
if( version_compare( EOS_DP_PRO_FDP_MIN_VERSION,EOS_DP_MU_VERSION ) > 0 ){
	require_once EOS_DP_PRO_PLUGIN_DIR.'/inc/fdp-update-required.php';
	return;
}

if( !function_exists( 'eos_dp_pro_get_option' ) ){
	//Get options in case of single or multisite installation.
	function eos_dp_pro_get_option( $option ){
		if( !is_multisite() ){
			return get_option( $option );
		}
		else{
			return get_blog_option( get_current_blog_id(),$option );
		}
	}
}

if( is_admin() || isset( $_GET['fdp-hooks'] ) ){
	add_action( 'admin_init','eos_dp_pro_load_plugin_textdomain' );
	add_filter( 'load_textdomain_mofile', 'eos_dp_pro_load_translation_file',99,2 ); //loads plugin translation files
}

//It loads plugin translation files
function eos_dp_pro_load_plugin_textdomain(){
	load_plugin_textdomain( 'eos-dp-pro', FALSE,EOS_DP_PRO_PLUGIN_DIR . '/languages/' );
}

//Filter function to read plugin translation files
function eos_dp_pro_load_translation_file( $mofile, $domain ) {
	if ( 'eos-dp-pro' === $domain ) {
		$loc = function_exists( 'get_user_locale' ) ? get_user_locale() : get_locale();
		$mofile = EOS_DP_PRO_PLUGIN_DIR . '/languages/eos-dp-pro-' . $loc . '.mo';
	}

	return $mofile;
}

if( ( wp_doing_ajax() && isset( $_REQUEST['action'] ) ) || isset( $_REQUEST['wc-ajax'] ) || ( !empty( $_POST ) && !defined( 'DOING_CRON' ) ) ){
	if( isset( $_REQUEST['action'] ) && false !== strpos( '_'.$_REQUEST['action'],'eos_dp_pro_' ) ){
		require EOS_DP_PRO_PLUGIN_DIR. '/admin/eos-dp-pro-ajax.php'; //file including all ajax requests functions
	}
	if(
	  ( isset( $_REQUEST ) && !empty( $_REQUEST ) )
	  && (
	    !isset( $_REQUEST['action'] )
	    || !in_array( $_REQUEST['action'],array( 'heartbeat' ) )
	  )
	){
		require_once EOS_DP_PRO_PLUGIN_DIR.'/admin/fdp-pro-actions.php';
	}
}

if( is_admin() ){
	require EOS_DP_PRO_PLUGIN_DIR . '/admin/eos-dp-pro-admin.php'; //file including the functions for back-end
}

if( isset( $_REQUEST['get_errors'] ) && $_REQUEST['get_errors'] == 'true' ){
	register_shutdown_function( 'eos_dp_pro_get_errors' );
}
//It gets the PHP warnings and errors after page loading
function eos_dp_pro_get_errors(){
	if( !defined( 'EOS_DP_PLUGIN_DIR' ) ) return;
	$err = error_get_last();
	if( is_array( $err ) ){
		echo '<div>eos-dp-errors-start'.esc_html( json_encode( $err ) ).'eos-dp-errors-end</div>';
	}
	echo 'eos-dp-pro-no-fatal-errors-occured';
	die();
	exit;
}

//Update options in case of single or multisite installation.
function eos_dp_pro_update_option( $option,$newvalue ){
	if( !is_multisite() ){
		$autoload = in_array( $option,array(
			'eos_dp_archives',
			'eos_dp_desktop',
			'eos_dp_mobile',
			'eos_dp_by_url',
			'eos_post_types_plugins',
			'eos_dp_opts',
			'eos_dp_pro_main',
			'eos_dp_unlogged',
			'active_plugins'
		) );
		return update_option( $option,$newvalue,$autoload );
	}
	else{
		return update_blog_option( get_current_blog_id(),$option,$newvalue );
	}
}

//Actions triggered after plugin activation or after a new site of a multisite installation is created
function eos_dp_pro_initialize_plugin( $networkwide ){
  if( is_multisite() && $networkwide ){
		wp_die( sprintf( __( "Freesoul Deactivate Plugins PRO can't be activated networkwide, but only on each single site. %s%s%s","eos-dp-pro" ),'<div><a class="button" href="'.admin_url( 'network/plugins.php' ).'">',__( 'Back to plugins','eos-dp-pro' ),'</a></div>' ) );
	}
	require EOS_DP_PRO_PLUGIN_DIR.'/plugin-activation.php';
}

register_activation_hook( __FILE__, 'eos_dp_pro_initialize_plugin' );

//Return FDP options kesys
function eos_dp_pro_options_keys( $only_tables = false ){
	$arr = array(
		'eos_dp_pro_main' => esc_html__( 'Main Settings (including CSS, JS, General bloat)','eos-dp-pro' ),
		'eos_dp_singles' => esc_html__( 'Singles','eos-dp-pro' ),
		'eos_post_types_plugins' => esc_html__( 'Post Types','eos-dp-pro' ),
		'eos_dp_archives' => esc_html__( 'Archives and Terms Archives','eos-dp-pro' ),
		'eos_dp_mobile' => esc_html__( 'Mobile','eos-dp-pro' ),
		'eos_dp_desktop' => esc_html__( 'Desktop','eos-dp-pro' ),
		'eos_dp_search' => esc_html__( 'Search','eos-dp-pro' ),
		'eos_dp_by_url' => esc_html__( 'Custom URLs (Frontend)','eos-dp-pro' ),
		'eos_dp_admin_theme' => esc_html__( 'Theme activation in Backend Singles','eos-dp-pro' ),
		'eos_dp_admin_setts' => esc_html__( 'Backend Pages','eos-dp-pro' ),
		'eos_dp_by_admin_url' => esc_html__( 'Custom Backend URLs','eos-dp-pro' ),
		'eos_dp_admin_url_theme' => esc_html__( 'Theme activation in Backend Custom URLs','eos-dp-pro' ),
		'eos_dp_integration_actions' => esc_html__( 'Plugin ajax actions','eos-dp-pro' ),
		'eos_dp_integretion_actions_theme' => esc_html__( 'Theme ajax actions','eos-dp-pro' ),
		'eos_dp_pro_ajax_setts' => esc_html__( 'Custom ajax actions','eos-dp-pro' ),
	);
	if( $only_tables ){
		unset( $arr['eos_dp_pro_main'] );
		unset( $arr['eos_dp_general_setts'] );
		unset( $arr['eos_dp_admin_theme'] );
		unset( $arr['eos_dp_admin_url_theme'] );
		unset( $arr['eos_dp_integretion_actions_theme'] );
	}
	return $arr;
}

add_action( 'init','eos_dp_pro_confirm_unsubscription' );
//It outputs a message after successful unsubscription fromm notifications
function eos_dp_pro_confirm_unsubscription(){
	if(
		isset( $_GET['p'] )
		&& esc_attr( urldecode( isset( $_GET['p'] ) ) ) === urldecode( isset( $_GET['p'] ) )
		&& isset( $_GET['e'] )
		&& sanitize_email( urldecode( $_GET['e'] ) ) === urldecode( $_GET['e'] )
		&& isset( $_GET['_fdp_unsubscribe_notification'] )
	){
		require EOS_DP_PRO_PLUGIN_DIR.'/inc/unsubscription.php';
	}
}

//Actions triggered after plugin deaactivation
function eos_dp_pro_deactivate_plugin(){
	$opts = eos_dp_pro_get_option( 'eos_dp_pro_main' );
	$opts['pro_activation'] = 'not_enabled';
	eos_dp_pro_update_option( 'eos_dp_pro_main',$opts );
}
register_deactivation_hook( __FILE__, 'eos_dp_pro_deactivate_plugin' );

if( isset( $_GET['fdp-hooks'] ) && in_array( $_GET['fdp-hooks'],array( 'actions','filters' ) ) ){
	require_once EOS_DP_PRO_PLUGIN_DIR.'/inc/class.fdp-show-hooks.php';
}
if( ( isset( $_GET['fdp-live'] ) && 'true' === $_GET['fdp-live'] ) || isset( $_COOKIE['fdp_live_session'] ) ){
	add_filter( 'show_admin_bar', '__return_false' );
	require_once EOS_DP_PRO_PLUGIN_DIR.'/inc/class.fdp-pro-live-preview.php';
}
if( ( isset( $_GET['fdp-assets'] ) && in_array( $_GET['fdp-assets'],array( 'styles','scripts' ) ) ) || isset( $_COOKIE['fdp_assets_session'] ) ){
	if( !isset( $_GET['action_id'] ) ){
		add_filter( 'show_admin_bar', '__return_false' );
		require_once EOS_DP_PRO_PLUGIN_DIR.'/inc/class.fdp-show-assets.php';
	}
	else{
		add_action( 'init',function(){
			add_filter( 'fdp_eos_dp_pro_main',function( $opts ){
				$transient_opts = get_site_transient( 'fdp_preview_assets_'.get_current_user_id().'_'.sanitize_key( $_GET['action_id'] ) );
				return $transient_opts ? $transient_opts : $opts;
			} );
			add_filter( 'fdp_post_meta_assets_active',function( $post_meta ){
				$transient_post_meta = get_site_transient( 'fdp_preview_assets_single_active_'.get_current_user_id().'_'.sanitize_key( $_GET['action_id'] ) );
				return $transient_post_meta ? $transient_post_meta : $post_meta;
			} );
		} );
	}
}

if( !is_admin() ){
	add_action( 'wp_print_styles','eos_dp_pro_manage_styles', PHP_INT_MAX  );
	add_action( 'wp_print_scripts','eos_dp_pro_manage_scripts', PHP_INT_MAX );
}

function eos_dp_pro_manage_styles(){
	eos_dp_pro_manage_assets( 'styles' );
}

function eos_dp_pro_manage_scripts(){
	eos_dp_pro_manage_assets( 'scripts' );
}

add_action( 'wp_footer','eos_dp_pro_footer' );

//All actions fired on wp_footer
function eos_dp_pro_footer(){
	eos_dp_pro_manage_assets( 'styles' );
	eos_dp_pro_manage_assets( 'scripts' );
}

//Dequeue assets
function eos_dp_pro_manage_assets( $asset_type ){
	if( 'styles' === $asset_type && defined( 'FDP_PRO_EXCLUDE_STYLES' ) && isset( $_GET[FDP_PRO_EXCLUDE_STYLES] ) && 'true' === $_GET[FDP_PRO_EXCLUDE_STYLES] ) return;
	if( 'scripts' === $asset_type && defined( 'FDP_PRO_EXCLUDE_SCRIPTS' ) && isset( $_GET[FDP_PRO_EXCLUDE_SCRIPTS] ) && 'true' === $_GET[FDP_PRO_EXCLUDE_SCRIPTS] ) return;
	if( isset( $_GET['load_assets'] ) && $asset_type === $_GET['load_assets'] ) return;
	if( isset( $_REQUEST['fdp-assets'] ) && !isset( $_GET['action_id'] ) ) return;
	$opts = apply_filters( 'fdp_eos_dp_pro_main',eos_dp_pro_get_option( 'eos_dp_pro_main' ) );
	$bloat = isset( $opts['general_bloat'] ) ? $opts['general_bloat'] : false;
	if( $bloat && isset( $bloat['cart_fragments'] ) && 'false' === $bloat['cart_fragments'] ){
		if( function_exists( 'is_cart' ) && !is_cart() && !is_checkout() ){
			wp_dequeue_script( 'wc-cart-fragments' );
		}
	}
	if( $bloat && isset( $bloat['woo_blocks_style'] ) && 'false' === $bloat['woo_blocks_style'] ){
		wp_dequeue_style( 'wc-blocks-vendors-style' );
		wp_dequeue_style( 'wc-all-blocks-style' );
	}
	if( !isset( $opts['styles'] ) && !isset( $opts['scripts'] ) ) return;
	global $post,$wp_styles,$wp_scripts;
	$post_id = false;
	$post_type = false;
	$single_active_meta = false;
	$dequeue = array();
	$dequeue[$asset_type] = array();
	if( function_exists( 'is_shop' ) && is_shop() ){
		$post_id = eos_dp_pro_get_option( 'woocommerce_shop_page_id' );
	}
	elseif( is_object( $post ) || is_front_page() ){
		$post_id = is_front_page() ? get_site_option( 'page_on_front' ) : $post->ID;
		if( isset( $post->post_type ) ){
			$post_type = $post->post_type;
		}
	}
	if( $post_id ){
		$single_active_meta = apply_filters( 'fdp_post_meta_assets_active',get_post_meta( $post_id,'_fdp_'.$asset_type.'_active',true ) );
	}
	if( isset( $opts[$asset_type] ) && '' !== $opts[$asset_type] && is_string( $opts[$asset_type] ) ){
		$opts_asset_type = json_decode( sanitize_text_field( stripslashes( $opts[$asset_type]) ),true );
		if( isset( $opts_asset_type['custom_urls'] ) && isset( $_SERVER['HTTP_HOST'] ) && isset( $_SERVER['REQUEST_URI'] ) ){
			$uri = $_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
			$urlsA = json_decode( sanitize_text_field( stripslashes( str_replace( '\n','',$opts_asset_type['custom_urls'] ) ) ),true );
			if( is_array( $urlsA ) && !empty( $urlsA ) ){
				foreach( $urlsA as $handle_url => $urlsString ){
					$urlA = explode( ',',str_replace( ',,',',',str_replace( ',,',',',str_replace( ' ',',',str_replace( PHP_EOL,',',$urlsString ) ) ) ) );
					if( !empty( $urlA ) ){
						foreach( $urlA as $url ){
							$url = str_replace( '[home]',get_home_url(),$url );
							if( '' === $url ) continue;
							foreach( array( 'https://','http://','www.' ) as $search ){
								$url = str_replace( $search,'',$url );
							}
							$pattern = '/'.str_replace( '/','\/',str_replace( '*','(.*)',str_replace( '**','*',$url ) ) ).'\s/';
							$pattern = '/'.str_replace( '/','\/',str_replace( '*','(.*)',str_replace( '**','*',$url ) ) ).'\s/i';
							$pattern = str_replace( '?','\?',$pattern );
							$pattern = str_replace( '&','\&',$pattern );
							preg_match( $pattern,$uri.' ',$matches );
							if( '*' === $url || ( !empty( $matches ) && count( $matches ) - 1 === substr_count( $pattern,'(.*)' ) ) ){
								if( 'styles' === $asset_type ){
									wp_deregister_style( $handle_url );
									wp_dequeue_style( $handle_url );
									break;
								}
								if( 'scripts' === $asset_type ){
									wp_deregister_script( $handle_url );
									wp_dequeue_script( $handle_url );
									break;
								}
							}
						}
					}
				}
			}
		}
		if( 'scripts' === $asset_type ){
			if( isset( $opts_asset_type['moved_head'] ) ){
				$moved_head = $opts_asset_type['moved_head'];
				foreach( $moved_head as $p_id => $script_handles ){
					foreach( $script_handles as $script_handle ){
						if( in_array( $script_handle,$wp_scripts->in_footer ) ){
							unset( $wp_scripts->in_footer[array_search( $script_handle,$wp_scripts->in_footer )] );
						}
						$wp_scripts->add_data( $script_handle, 'group', 0 );
					}
				}
			}
			if( isset( $opts_asset_type['moved_footer'] ) ){
				$moved_footer = $opts_asset_type['moved_footer'];
				foreach( $moved_footer as $p_id => $script_handles ){
					foreach( $script_handles as $script_handle ){
						if( !in_array( $script_handle,$wp_scripts->in_footer ) ){
							$wp_scripts->in_footer[] = $script_handle;
							$wp_scripts->add_data( $script_handle, 'group', 1 );
						}
					}
				}
			}
		}
		foreach( $opts_asset_type as $handle => $arr ){
			if( isset( $arr['single'] ) && '' !== $arr['single'] && $post_id && 0 !== absint( $post_id ) ){
				if( $single_active_meta && '' !== $single_active_meta && '[]' !== $single_active_meta ){
					if( in_array( $handle,json_decode( sanitize_text_field( stripslashes( $single_active_meta ) ),true ) ) ){
						continue;
					}
				}
				$single_ids = explode( ',',rtrim( $arr['single'],',' ) );
				if( in_array( $post_id,$single_ids ) ){
					$dequeue[$asset_type][] = $handle;
					continue;
				}
			}
			elseif( isset( $arr['post_types'] ) && $post_type && '' !== $arr['post_types'] && !is_archive() ){
				$post_types = explode( ',',rtrim( $arr['post_types'],',' ) );
				if( in_array( $post_type,$post_types ) ){
					$singles_active = $single_active_meta ? json_decode( stripslashes( $single_active_meta ),true ) : false;
					if( !$singles_active || !in_array( $handle,$singles_active ) ){
						$dequeue[$asset_type][] = $handle;
						continue;
					}
				}
			}
			elseif( is_archive() ){
				$queried_object = get_queried_object();
				if( $queried_object ){
					if( isset( $arr['archives'] ) && '' !== $arr['archives'] ){
						$archives = explode( ',',rtrim( $arr['archives'],',' ) );
						if( isset( $queried_object->name ) && '' !== $queried_object->name && is_array( $archives ) && in_array( $queried_object->name,$archives ) ){
							$dequeue[$asset_type][] = $handle;
							continue;
						}
					}
					if( isset( $arr['terms'] ) && '' !== $arr['terms'] && isset( $queried_object->taxonomy ) ){
						$terms = explode( ',',rtrim( $arr['terms'],',' ) );
						if( is_array( $terms ) && in_array( $queried_object->taxonomy,$terms ) ){
							$dequeue[$asset_type][] = $handle;
							continue;
						}
					}
				}
			}
		}
	}
	if( defined( 'FDP_BETA_VERSION' ) ){
		if( isset( $opts_asset_type['reduced_styles'] ) ){
			$reduced_opts = $opts_asset_type['reduced_styles'];
			if( isset( $reduced_opts[$post_id] ) ){
				$reduced_styles = $reduced_opts[$post_id];
				$upload_dir = wp_upload_dir();
				foreach( $reduced_styles as $style_handle ){
					if( isset( $wp_styles->registered[$style_handle] ) ){
						$wp_styles->registered[$style_handle]->src = esc_url( $upload_dir['baseurl'].'/FDP/css/fdp-'.$post_id.'-'.substr( md5( $post_id.$style_handle ),0,8 ) ).'.css';
					}
				}
			}
		}
	}
	if( 'styles' === $asset_type && isset( $dequeue['styles'] ) && is_array( $dequeue['styles'] ) && !empty( $dequeue['styles'] ) ){
		foreach( $dequeue['styles'] as $handle ){
			wp_deregister_style( $handle );
			wp_dequeue_style( $handle );
		}
	}
	if( 'scripts' === $asset_type && isset( $dequeue['scripts'] ) && is_array( $dequeue['scripts'] ) && !empty( $dequeue['scripts'] ) ){
		foreach( $dequeue['scripts'] as $handle ){
			wp_deregister_script( $handle );
			wp_dequeue_script( $handle );
		}
	}
}

//Helper function to check if all levels of array are set
function eos_dp_pro_isset_multi( $arr,$keys ){
	if( !is_array( $arr ) ) return false;
  foreach( $keys as $key ){
      if( !isset( $arr[$key] ) ){
          return false;
      }
      $arr = $arr[$key];
  }
  return $arr;
}

add_action( 'wp_enqueue_scripts', 'eos_dp_pro_move_jquery_to_footer' );
//Move jquery to footer
function eos_dp_pro_move_jquery_to_footer() {
	if( defined( 'FDP_JQUERY_FOOTER' ) && FDP_JQUERY_FOOTER ){
	   wp_scripts()->add_data( 'jquery', 'group', 1 );
	   wp_scripts()->add_data( 'jquery-core', 'group', 1 );
	   wp_scripts()->add_data( 'jquery-migrate', 'group', 1 );
 	}
}

add_action( 'wp_default_scripts', 'eos_dp_pro_remove_jquery_migrate',999999999 );
//Remove jquery migrate
function eos_dp_pro_remove_jquery_migrate( $scripts ) {
  if( defined( 'FDP_REMOVE_JQUERY_MIGRATE' ) && FDP_REMOVE_JQUERY_MIGRATE  && !is_admin() && isset( $scripts->registered['jquery'] ) ) {
    $script = $scripts->registered['jquery'];
  	if ( $script->deps ) {
      $script->deps = array_diff( $script->deps, array( 'jquery-migrate' ) );
 		}
 	}
 }

 function eos_dp_pro_unneeded_actions(){
 	return array(
 	 'rsd_link' => array( 'wp_head',10,__( 'Really Simple Discovery link','eos-dp-pro' ),null,null,__( "It adds the Really Simple Discovery link. It's an XML format and a publishing convention for making services exposed by the blog discoverable by client software.") ),
 	 'wp_shortlink_wp_head' => array( 'wp_head',10,__( 'Shortlink','eos-dp-pro' ),null,null,__( "Shortlink is nothing but the shorter version of the post or page url. Usually you don't need it. If unchecked it will be removed everywhere on the frontend" ) ),
 	 'wp_generator' => array( 'wp_head',10,__( 'Generator meta tag','eos-dp-pro' ),null,null,__( "It adds a meta in the header with the version of WordPress. Usually you don't need it. If unchecked it will be removed everywhere on the frontend","eos-dp-pro" ) ),
 	 'wlwmanifest_link' => array( 'wp_head',10,__( 'Window Live Writer link','eos-dp-pro' ),null,null,__( 'It adds the Windows Live Writer link. You need it if you want to update your blog without logging in to your backend.','eos-dp-pro' ) ),
 	 'rest_output_link_wp_head' => array( 'wp_head',10,__( 'REST API link tag into page header','eos-dp-pro' ),null,null,__( "It adds the REST API link tag into the header. You need it only if your website uses the Rest API.","eos-dp-pro" ) ),
 	 'rest_output_link_header' => array( 'template_redirect',11,__( 'Link header for the REST API','eos-dp-pro' ),null,null, __( 'It adds an header including the Rest API link. You need it only if your website uses the Rest API.','eos-dp-pro' ) )
 	);
 }

add_action( 'init','eos_dp_pro_remove_unneeded_actions' );
//Remove unneeded actions.
function eos_dp_pro_remove_unneeded_actions(){
	$opts = eos_dp_pro_get_option( 'eos_dp_pro_main' );
	if( !isset( $opts['general_bloat'] ) ) return;
	$opts = $opts['general_bloat'];
	if( !empty( $opts ) ){
		$actions = eos_dp_pro_unneeded_actions();
		foreach( $actions as $key => $arr ){
			$value = $opts[$key];
			if( isset( $opts[$key] ) && 'false' === $opts[$key] ){
				remove_action( $arr[0],$key,$arr[1] );
			}
		}
		if( isset( $opts['global_style'] ) && 'false' === $opts['global_style'] ){
			remove_action( 'wp_enqueue_scripts', 'wp_enqueue_global_styles' );
			remove_action( 'wp_body_open', 'wp_global_styles_render_svg_filters' );
			remove_action( 'wp_footer', 'wp_enqueue_global_styles', 1 );
		}
		if( isset( $opts['sworg_dns_prefetch'] ) && 'false' === $opts['sworg_dns_prefetch'] ){
			add_filter( 'wp_resource_hints','eos_dp_pro_remove_sworg_dns_prefetch',20,2);
		}
		if( isset( $opts['xmlrpc'] ) && 'false' === $opts['xmlrpc'] ){
			add_filter( 'xmlrpc_enabled','__return_false' );
		}
		if( isset( $opts['emoji'] ) && 'false' === $opts['emoji'] ){
			remove_action( 'wp_head','print_emoji_detection_script',7 );
			remove_action( 'wp_print_styles','print_emoji_styles',10 );
		}
		if( isset( $opts['rest_api'] ) && 'false' === $opts['rest_api'] ){
			add_filter( 'rest_authentication_errors','eos_dp_pro_disable_rest_api_not_logged' );
		}
		if( isset( $opts['heartbeat'] ) && 'false' === $opts['heartbeat'] ){
			wp_deregister_script('heartbeat');
		}
		if( isset( $opts['gfonts'] ) && 'false' === $opts['gfonts'] && !is_admin() ){
		  ob_start( 'eos_dp_pro_disable_google_fonts' );
		}
		if( isset( $opts['gutenberg'] ) && 'false' === $opts['gutenberg'] ){
			add_filter('use_block_editor_for_post', '__return_false');
			add_action( 'wp_print_styles', 'eos_dp_pro_dequeue_gutenberg' );
		}
		if( isset( $opts['cron'] ) && 'false' === $opts['cron'] ){
			if( !defined( 'DISABLE_WP_CRON' ) ){
				define( 'DISABLE_WP_CRON',true );
			}
		}
		if( isset( $opts['autosave'] ) && 'false' === $opts['autosave'] ){
			if( !defined('AUTOSAVE_INTERVAL') ){
				define( 'AUTOSAVE_INTERVAL', 864000 );
			}
			wp_deregister_script( 'autosave' );
		}
		if( isset( $opts['cookies_assets'] ) && 'false' === $opts['cookies_assets'] ){
			require_once EOS_DP_PRO_PLUGIN_DIR.'/inc/fdp-remove-cookies.php';
		}

	}
}

add_filter( 'heartbeat_settings',function( $settings ) {
	$opts = eos_dp_pro_get_option( 'eos_dp_pro_main' );
	if( !isset( $opts['general_bloat'] ) ) return $settings;
	$opts = $opts['general_bloat'];
	if( isset( $opts['heartbeat_value'] ) && absint( $opts['heartbeat_value'] ) > 0 ){
		$settings['interval'] = absint( $opts['heartbeat_value'] );
	}
	return $settings;
} );

add_filter( 'wp_revisions_to_keep',function( $n ){
	$opts = eos_dp_pro_get_option( 'eos_dp_pro_main' );
	$opts = isset( $opts['general_bloat'] ) ? $opts['general_bloat'] : array();
	if( isset( $opts['revisions'] ) && 'false' === $opts['revisions'] ){
		return 0;
	}
	elseif( isset( $opts['revisions_value'] ) && absint( $opts['revisions_value'] ) > 0 && 9999 !== absint( $opts['revisions_value'] ) ){
		return absint( $opts['revisions_value'] );
	}
  return $n;
} );

//we don't need dns-prefetch for s.w.org domain
function eos_dp_pro_remove_sworg_dns_prefetch( $urls, $relation_type ){
	$n = 0;
	foreach( $urls as $url ){
		if( $url && is_string( $url ) && false !== strpos( $url,'s.w.org' ) ){
			$k = $n;
		}
		++$n;
	}
	if( isset( $k ) ){
		unset( $urls[$k] );
	}
	return $urls;
}

//Disable Rest API for not logged users
function eos_dp_pro_disable_rest_api_not_logged( $result ){
  if( true === $result || is_wp_error( $result ) ) {
      return $result;
  }
  if ( ! is_user_logged_in() ){
      return new WP_Error(
          'rest_not_logged_in',
          __( 'You are not currently logged in.','eos-dp-pro' ),
          array( 'status' => 401 )
      );
  }
  return $result;
}

add_action( 'wp_default_scripts','eos_dp_pro_manage_jquery' );
//Disable jQuery Migrate or move jQuery to the footer depending on the settings
function eos_dp_pro_manage_jquery( $wp_scripts ){
	$opts = eos_dp_pro_get_option( 'eos_dp_pro_main' );
	$bloat = isset( $opts['general_bloat'] ) ? $opts['general_bloat'] : false;
  if( !is_admin() ){
		if( $bloat && isset( $bloat['jmigrate'] ) && 'false' === $bloat['jmigrate'] ){
	    $wp_scripts->remove( 'jquery');
	    $wp_scripts->add( 'jquery',false,array( 'jquery-core' ),false,1 );
		}
		if( $bloat && isset( $bloat['jquery'] ) && 'false' === $bloat['jquery'] ){
			$wp_scripts->add_data( 'jquery', 'group', 1 );
			$wp_scripts->add_data( 'jquery-core', 'group', 1 );
			$wp_scripts->add_data( 'jquery-migrate', 'group', 1 );
		}
  }
}

//Replace Google Fonts with system fonts
function eos_dp_pro_disable_google_fonts( $html ){
  $html = preg_replace('/<link.*fonts.googleapis.com.*>/i', '', $html);
  $html = preg_replace('/<link.*fonts.gstatic.com.*>/i', '', $html);
  $style =
    "<style>body{font-family:-apple-system,system-ui,BlinkMacSystemFont,'Segoe UI',Roboto,Oxygen,Ubuntu,Cantarell,'Fira Sans','Droid Sans','Helvetica Neue',sans-serif}code{font-family:Menlo,Consolas,Monaco,Liberation Mono,Lucida Console,monospace}</style>";
  $html = str_replace('</head>', $style . '</head>', $html);
  return $html;
}

//Disable Gutenberg completelly
function eos_dp_pro_dequeue_gutenberg() {
	wp_dequeue_style( 'wp-core-blocks' );
	wp_dequeue_style( 'wp-block-library' );
	wp_deregister_style( 'wp-core-blocks' );
	wp_deregister_style( 'wp-block-library' );
}

add_action( 'wp_head','eos_dp_pro_head_scripts',1 );
//Inline scripts in the head
function eos_dp_pro_head_scripts(){
	$assets = false;
	if( defined( 'FDP_PRO_ASSETS_BY_COOKIES' ) && is_array( FDP_PRO_ASSETS_BY_COOKIES ) ){
		$assets = FDP_PRO_ASSETS_BY_COOKIES;
	}
	else{
		$opts = eos_dp_pro_get_option( 'eos_dp_pro_main' );
		if( !isset( $opts['assets_by_cookie'] ) || empty( $opts['assets_by_cookie'] ) ) return;
		$assets = $opts['assets_by_cookie'];
	}
	if( $assets && !isset( $assets['scripts'] ) && !isset( $assets['styles'] ) ) return;
	require_once EOS_DP_PRO_PLUGIN_DIR.'/inc/fdp-assets-by-cookies.php';
}

//Aabort script by cookie according to the settings
function eos_dp_pro_script_by_cookie( $tag,$handle,$src ) {
	global $abort_sripts;
	if( $abort_sripts && is_array( $abort_sripts ) && !empty( $abort_sripts ) ){
		foreach( $abort_sripts as $k => $arr ){
			if( $src && false !== strpos( $src,$arr[2] ) ){
				$script = '<script>fdp_maybe_abort_script(\''.esc_js( esc_attr( $arr[0] ) ).'\',\''.esc_js( $arr[1] ).'\',\''.esc_js( esc_url( $src ) ).'\');</script>';
				return str_replace( '</script>','</noscript>',str_replace( '<script','<noscript data-fdp_id="'.$arr[0].'-js"',$tag ) ).$script;
			}
		}
	}
	return $tag;
}

//Aabort style by cookie according to the settings
function eos_dp_pro_style_by_cookie( $tag,$handle,$src,$media ) {
	global $abort_styles;
	if( $abort_styles && is_array( $abort_styles ) && !empty( $abort_styles ) ){
		foreach( $abort_styles as $k => $arr ){
			if( $src && false !== strpos( $src,$arr[2] ) ){
				$script = '<script>fdp_maybe_abort_style(\''.esc_js( esc_attr( $arr[0] ) ).'\',\''.esc_js( $arr[1] ).'\',\''.esc_js( esc_url( $src ) ).'\',\''.esc_js( $media ).'\');</script>';
				return str_replace( $media,'none',str_replace( '<link','<link data-fdp_id="'.$arr[0].'-css"',$tag ) ).$script;
			}
		}
	}
	return $tag;
}

add_action ( 'shutdown', function(){
  if( function_exists( 'get_current_user_id' ) && get_current_user_id() ){
    $rec_id = get_site_transient( 'eos_dp_pro_recording_id_'.get_current_user_id() );
    if( $rec_id && ( !isset( $_REQUEST['action'] ) || ( false === strpos( sanitize_text_field( $_REQUEST['action'] ),'eos_dp_pro_hooks_' ) && false === strpos( sanitize_text_field( $_REQUEST['action'] ),'eos_dp_updated_key_for_preview' ) ) ) && ( !isset( $_GET['page'] ) || false === strpos( sanitize_text_field( $_GET['page'] ),'eos_dp_' ) ) ){
			$all_hooks = get_site_transient( 'eos_dp_pro_recording_hooks_'.sanitize_key( $rec_id ) );
			$uris = get_site_transient( 'eos_dp_pro_recording_uri_'.sanitize_key( $rec_id ).'_'.get_current_user_id() );
			$uris = $uris && is_array( $uris ) ? $uris : array();
      $uri = isset( $_SERVER['REQUEST_URI'] ) ? $_SERVER['REQUEST_URI'] : 'unknown';
			if( 'unknown' !== $uri && wp_doing_ajax() ){
				if( isset( $_REQUEST['action'] ) ){
					$uri = add_query_arg( 'action',$_REQUEST['action'] );
				}
				elseif( isset( $_REQUEST['wc-ajax'] ) ){
					$uri = add_query_arg( 'action',$_REQUEST['wc-ajax'] );
				}
			}
			$uris[] = $uri;

			$hooks = array();
      foreach( $GLOBALS['wp_filter'] as $tag => $obj ){
        $callbacks = $obj->callbacks;
        foreach( $callbacks as $priority => $functions_arr ){
          foreach( $functions_arr as $k => $a ){
            $source = eos_dp_pro_function_who( $k );
            $hooks[$tag][$priority][] = array(
              'callback' => esc_attr( $k ),
              'args' => absint( $a['accepted_args'] ),
              'type' => esc_attr( $source['type'] ),
              'who' => esc_attr( $source['who'] ),
              'path' => esc_attr( add_query_arg( array( 'id' => $source['who'],'page' => 'eos_dp_code_browser','path' => $source['path'] ),admin_url() ) )
            );
          }
        }
      }
			$all_hooks[esc_url( $uri )] = $hooks;
      set_site_transient( 'eos_dp_pro_recording_hooks_'.sanitize_key( $rec_id ),$all_hooks,60 );
      set_site_transient( 'eos_dp_pro_recording_uri_'.sanitize_key( $rec_id ).'_'.get_current_user_id(),sanitize_text_field( implode( ',',$uris ) ),60 );
    }
  }
} );

//Return the file where a function or class is defined
function eos_dp_pro_function_who( $function_name ){
  $class_name = $function_name;
  if( false !== strpos( $function_name,':' ) ){
    $a = explode( ':',$function_name );
    if( isset( $a[1] ) ){
      $class_name = $a[0];
    }
  }
  if( function_exists( $function_name ) ){
    $reflector = new \ReflectionFunction( $function_name );
  }
  elseif( class_exists( $class_name ) ){
    $reflector = new \ReflectionClass( $class_name );
  }
  else{
    return false;
  }
  $output = array();
  $path = $reflector->getFileName();
  $plugindir = defined( PLUGINDIR ) ? PLUGINDIR.'/' : 'wp-content/plugins/';
  $muplugindir = str_replace( ABSPATH,'',EOS_DP_MU_PLUGIN_DIR ).'/';
  $themedir = str_replace( ABSPATH,'',get_theme_root() );
  if( false !== strpos( $path,$plugindir ) ){
    $path = str_replace( ABSPATH,'',$path );
    $output['type'] = 'plugin';
    $output['path'] = $path;
    $path = str_replace( $plugindir,'',$path );
    $whoA = explode( '/',$path );
    $output['who'] = $whoA[0];
  }
  elseif( false !== strpos( $path,$muplugindir ) ){
    $path = str_replace( ABSPATH,'',$path );
    $output['type'] = 'mu-plugin';
    $output['path'] = $path;
    $path = str_replace( $muplugindir,'',$path );
    $whoA = explode( '/',$path );
    $output['who'] = 'mu-plugin';
  }
  elseif( false !== strpos( $path,$themedir ) ){
    $childdir = get_stylesheet_directory();
    $parentdir = get_template_directory();
    if( false !== strpos( $path,$parentdir ) ){
      $output['type'] = 'theme';
    }
    if( false !== strpos( $path,$childdir ) ){
      $output['type'] = 'child-theme';
    }
    $output['who'] = dirname( str_replace( get_theme_root().'/','',$path ) );
    if( false !== strpos( $output['who'],'/' ) ) $output['who'] = dirname( $output['who'] );
    $output['path'] = str_replace( ABSPATH,'',$path );
  }
  else{
    $path = str_replace( ABSPATH,'',$path );
    if( 0 === strpos( $path,'wp-' ) ){
      $output['type'] = 'core';
      $output['who'] = 'core';
    }
    else{
      $output['type'] = 'unkown';
      $output['who'] = 'unkown';
    }
    $output['path'] = $path;
  }
  return array_map( 'esc_attr',$output );
}

add_action( 'updated_option',function( $option,$old_value,$value ){
	//Remove autoload depending on the FDP settings
	$no_autoloads = eos_dp_pro_get_option( 'eos_dp_noautoload' );
	if( !$no_autoloads ) return $value;
	$no_autoloads = json_decode( stripslashes( $no_autoloads ),true );
	foreach( $no_autoloads as $opt => $size ){
		if( $opt === $option ){
			eos_dp_pro_update_autoload( $opt );
		}
	}
	return $value;
},999999999,3 );

function eos_dp_pro_update_autoload( $option,$autoload = 'no' ){
	global $wpdb;
	$result = $wpdb->update( $wpdb->options,array( 'autoload' => $autoload ), array( 'option_name' => $option ) );
}

if( isset( $_REQUEST['fdp_whois_option'] ) && isset( $_REQUEST['nonce'] ) ){
	require_once EOS_DP_PRO_PLUGIN_DIR.'/inc/fdp-option-info.php';
}

if( isset( $_REQUEST['tool'] ) && 'whois' === $_REQUEST['tool'] && isset( $_REQUEST['eos_dp_preview'] ) && 'true' === $_REQUEST['eos_dp_preview'] ){
	add_filter( 'show_admin_bar', '__return_false' );
}

add_action( 'setted_transient',function( $transient ){
	if( 'dirsize_cache' === $transient ){
		$opts = apply_filters( 'fdp_eos_dp_pro_main',eos_dp_pro_get_option( 'eos_dp_pro_main' ) );
		if( isset( $opts['general_bloat'] ) ){
			$opts = $opts['general_bloat'];
			if( isset( $opts['dirsize_cache'] ) && false === $opts['dirsize_cache'] ){
				delete_transient( $transient );
			}
		}
	}
} );

add_filter( 'woocommerce_defer_transactional_emails',function( $bool ){
	$opts = apply_filters( 'fdp_eos_dp_pro_main',eos_dp_pro_get_option( 'eos_dp_pro_main' ) );
	$bloat = isset( $opts['general_bloat'] ) ? $opts['general_bloat'] : false;
	if( $bloat && isset( $bloat['woo_emails'] ) && 'false' === $bloat['woo_emails'] ){
		return true;
	}
	return $bool;
} );

add_action( 'comment_form',function( $post_id ){
	$opts = apply_filters( 'fdp_eos_dp_pro_main',eos_dp_pro_get_option( 'eos_dp_pro_main' ) );
	$bloat = isset( $opts['general_bloat'] ) ? $opts['general_bloat'] : false;
	if( $bloat && isset( $bloat['comment_spam'] ) && 'false' === $bloat['comment_spam'] ){
		?>
		<input id="fdp-coomment-key" name="fdp-comment-key" type="hidden" value="<?php echo md5( $post_id.ABSPATH ); ?>"/>
		<?php
	}
} );

add_action( 'comment_post',function( $comment_ID,$comment_approved,$commentdata ){
	//Delete comment spam based on the general bloat settings.
	if( is_admin() ) return $comment_ID;
	$opts = apply_filters( 'fdp_eos_dp_pro_main',eos_dp_pro_get_option( 'eos_dp_pro_main' ) );
	$bloat = isset( $opts['general_bloat'] ) ? $opts['general_bloat'] : false;
	if( $bloat && isset( $bloat['comment_spam'] ) && 'false' === $bloat['comment_spam'] ){
		$commentdata = get_comment( $comment_ID,ARRAY_A );
	  	$postId = $commentdata['comment_post_ID'];
		$post = get_post( $postId );
		if( is_object( $post ) && !in_array( $post->post_type,array( 'post','page' ) ) ) return $comment_ID;
		if( !isset( $_POST['fdp-comment-key'] ) || md5( $commentdata['comment_post_ID'].ABSPATH ) !== $_POST['fdp-comment-key'] ){
	    wp_delete_comment( $comment_ID,true );
	    wp_die( __( 'Comment detected as spam','eos-dp-pro' ) );
		exit;
	  }
	}
  return $comment_ID;
},10,3 );

function eos_dp_pro_backtrace(){
	$trace = debug_backtrace();
	$trace1 = $trace[1];
	$trace = array_reverse( $trace );
	$output = $code = '';
	$cause = $line = $file = false;
	$plugindir = defined( PLUGINDIR ) ? PLUGINDIR.'/' : 'wp-content/plugins/';
	$themedir = str_replace( ABSPATH,'',get_theme_root() );
	foreach( $trace as $arr ){
	  if( isset( $arr['file'] )  ){
	    $line = $arr['line'];
	    $file = $arr['file'];
	    $function = $arr['function'];
	    if( false !== strpos( $arr['file'],$plugindir  ) ){
	      //Plugin
	      $pArr = explode( $plugindir,$arr['file'] );
	      if( isset( $pArr[1] ) ){
	        $cause = strtoupper( str_replace( '-',' ',dirname( $pArr[1],substr_count( $pArr[1],'/' ) ) ) );
	        break;
	      }
	    }
	    elseif( false !== strpos( $arr['file'],$themedir ) ){
	      //Theme
	      $tArr = explode( $themedir,$arr['file'] );
	      if( isset( $tArr[1] ) ){
	        $cause = strtoupper( ltrim( str_replace( '-',' ',dirname( $pArr[1],substr_count( $pArr[1],'/' ) - 1 ) ),'/' ) );
	      break;
	      }
	    }
	    elseif( false !== strpos( $arr['file'],WPMU_PLUGIN_DIR ) ){
	      //MU Plugin
	      $muArr = explode( WPMU_PLUGIN_DIR,$arr['file'] );
	      if( isset( $muArr[1] ) ){
	        $cause = strtoupper( rtrim( ltrim( str_replace( '-',' ',$muArr[1] ),'/' ),'.php' ) );
	        $break;
	      }
	    }
	  }
	}
	return array( 'plugin' => $cause,'file' => $file,'function' => $function,'line' => $line );
}

// Return plugin name by slug.
function eos_dp_pro_get_plugin_name_by_slug( $slug ){
	return function_exists( 'eos_dp_get_plugin_name_by_slug' ) ? eos_dp_get_plugin_name_by_slug( $slug ) : str_replace( '-',' ',dirname( sanitize_text_field( $slug ) ) );
}