<?php
defined( 'ABSPATH' ) || exit;
//Remove hook onject
class FDP_pro_remove_hook {
  public $hook_name;
  public $hook_function;
  public $priority;
  function __construct( $hook_name,$hook_function,$priority ){
    $this->hook_name = $hook_name;
    $this->hook_function = $hook_function;
    $this->priority = $priority;
    foreach( array( 'muplugins_loaded','plugins_loaded','after_setup_theme' ) as $action ){
      add_action( $action,function(){
        $this->remove_hook_action();
      } );
    }
  }
  function remove_hook_action(){
    add_action( $this->hook_name,$this->remove_hook(),absint( $this->priority - 1 ) );
  }
  function remove_hook(){
    if( false !== strpos( $this->hook_function,'–>' ) ){
      $arr = explode( '–>',str_replace( ' ','',$this->hook_function ) );
      $this->remove_class_filter( $this->hook_name,$arr[0],$arr[1],$this->priority );
    }
    else{
      remove_action( $this->hook_name,$this->hook_function,$this->priority );
    }
  }
  function remove_class_filter( $tag,$class_name,$method_name,$priority ) {
      global $wp_filter;
      // Check that filter actually exists first
      if ( ! isset( $wp_filter[ $tag ] ) ) {
          return FALSE;
      }
      if ( is_object( $wp_filter[ $tag ] ) && isset( $wp_filter[ $tag ]->callbacks ) ) {
          // Create $fob object from filter tag, to use below
          $fob       = $wp_filter[ $tag ];
          $callbacks = &$wp_filter[ $tag ]->callbacks;
      } else {
          $callbacks = &$wp_filter[ $tag ];
      }
      // Exit if there aren't any callbacks for specified priority
      if ( ! isset( $callbacks[ $priority ] ) || empty( $callbacks[ $priority ] ) ) {
          return FALSE;
      }
      // Loop through each filter for the specified priority, looking for our class & method
      foreach ( (array) $callbacks[ $priority ] as $filter_id => $filter ) {
          // Filter should always be an array - array( $this, 'method' ), if not goto next
          if ( ! isset( $filter['function'] ) || ! is_array( $filter['function'] ) ) {
              continue;
          }
          // If first value in array is not an object, it can't be a class
          if ( ! is_object( $filter['function'][0] ) ) {
              continue;
          }
          // Method doesn't match the one we're looking for, goto next
          if ( $filter['function'][1] !== $method_name ) {
              continue;
          }
          // Method matched, now let's check the Class
          if ( get_class( $filter['function'][0] ) === $class_name ) {
              // WordPress 4.7+ use core remove_filter() since we found the class object
              if ( isset( $fob ) ) {
                  // Handles removing filter, reseting callback priority keys mid-iteration, etc.
                  $fob->remove_filter( $tag, $filter['function'], $priority );
              } else {
                  // Use legacy removal process (pre 4.7)
                  unset( $callbacks[ $priority ][ $filter_id ] );
                  // and if it was the only filter in that priority, unset that priority
                  if ( empty( $callbacks[ $priority ] ) ) {
                      unset( $callbacks[ $priority ] );
                  }
                  // and if the only filter for that tag, set the tag to an empty array
                  if ( empty( $callbacks ) ) {
                      $callbacks = array();
                  }
                  // Remove this filter from merged_filters, which specifies if filters have been sorted
                  unset( $GLOBALS['merged_filters'][ $tag ] );
              }
              return TRUE;
          }
      }
      return FALSE;
    }
}
